;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 152 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "tstSSIMG.vec"
	.INCLUDE "tstSSIMG.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xF8)
	LDI  R29,HIGH(0xF8)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xF8
;       1 /*************************************************************
;       2 Project :  Test des fonctionnalits de la carte ATMEGA8535 SSI
;       3 Create :  8/03/2003 pour AT90S8535
;       4 Version : 1
;       5 Rvision : 6     Date    : 15/03/2008
;       6 Author  : Philippe Mariano                
;       7 Company : LYCEE Pierre Emile MARTIN       
;       8 Comments: Test des BP, des DELs, des entres TOR, du Buzzer,
;       9 de l'entre analogique, du capteur de temprature DS1621,
;      10 de l'EEPROM externe, de l'HTR PCF8583, de la liaison RS232, de la sortie 
;      11 PWMA, d'un clavier 102 touches
;      12 
;      13 Chip type           : ATMEGA8535
;      14 Clock frequency     : 8,000000 MHz
;      15 Memory model        : Small
;      16 Internal SRAM size  : 512
;      17 External SRAM size  : 0
;      18 Data Stack size     : 152 !!!!!!!!!!!!!!!!!
;      19 ************************************************************/
;      20 
;      21 #include <mega8535.h>
;      22 
;      23 // Librairies non gnres par Wizard ( rajouter manuellement)
;      24 //-----------------------------------------------------------------      
;      25 #include <delay.h>    // contient la fonction delay_ms
;      26 #include <stdio.h>    // contient la fonction sprintf 
;      27 #include <stdlib.h>   // contient la fonction itoa
;      28 #include <math.h>
;      29 
;      30 // Ces fichiers d'en-tte et les librairies correspondantes doivent tre placs
;      31 // dans les rpertoires c:/cvavr/inc et c:/cvavr/lib
;      32 // -------------------------------------------------------------------------------
;      33 #include <ssi.h> 	// Sous-programme Affiche_LCD, Lire_BP  
;      34 
;      35 #include <LitClav102.h> // Sous-programme de dsrialisation et de dcodage de la
;      36 			// trame issue du clavier de PC (102T) 
;      37 #include <scancode2.h> 	// Table de transcodage du clavier de PC (102T)

	.CSEG
;      38  			// Cette table doit tre adapte au clavier utilis 
;      39 //**********************************************************************************     
;      40 
;      41 // Boolens
;      42 // --------------------------------
;      43 #define VRAI 1
;      44 #define FAUX 0
;      45 
;      46 // Accs aux caractres en CGRAM 
;      47 // --------------------------------
;      48 #define Caractere_FlecheH	0 
;      49 #define Caractere_FlecheB	1
;      50 
;      51 // @ I2C HTR
;      52 // --------------------------------
;      53 #define	adresse_HTR	0
;      54 
;      55 // Adresse CGRAM de l'afficheur LCD
;      56 // --------------------------------
;      57 #define Add_FlecheH_CGRAM 0x40 // @1 Caractre flche haut
;      58 #define Add_FlecheB_CGRAM 0x48 // @2 Caractre flche bas
;      59 
;      60 
;      61 // ----------------------------------------  page 1 ------------------------------------------------
;      62 
;      63 
;      64 // I2C Bus functions
;      65 #asm
;      66    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      67    .equ __sda_bit=3
   .equ __sda_bit=3
;      68    .equ __scl_bit=7
   .equ __scl_bit=7
;      69 #endasm

;      70 #include <i2c.h>
;      71 
;      72 // DS1621 Thermometer/Thermostat functions
;      73 #include <ds1621.h>
;      74 
;      75 // PCF8583 Real Time Clock functions
;      76 #include <pcf8583.h>
;      77 
;      78 // Alphanumeric LCD Module functions
;      79 #asm
;      80    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      81 #endasm

;      82 #include <lcd.h>
;      83 
;      84 #define ADC_VREF_TYPE 0x00
;      85 // Read the AD conversion result
;      86 unsigned int read_adc(unsigned char adc_input)
;      87 {
_read_adc:
;      88 ADMUX=adc_input|ADC_VREF_TYPE;
	LD   R30,Y
	OUT  0x7,R30
;      89 // Start the AD conversion
;      90 ADCSRA|=0x40;
	SBI  0x6,6
;      91 // Wait for the AD conversion to complete
;      92 while ((ADCSRA & 0x10)==0);
_0x75:
	SBIS 0x6,4
	RJMP _0x75
;      93 ADCSRA|=0x10;
	SBI  0x6,4
;      94 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
;      95 }
;      96 
;      97 
;      98 // Declare your global variables here   
;      99 // --------------------------------------------------------------------------------------
;     100 /* Communication avec le clavier PS2
;     101 Le programme principal se synchronise avec la routine d'interruption situe dans 
;     102 la bibliothque LitClav.lib avec les variables ci-dessous
;     103 ----------------------------------------------------------------------------------------*/ 
;     104 unsigned char 	g_key_ASCII=''; 	// Contient le code ASCII de la touche presse  
;     105 					// ( initialiser avec uncaractre n'existant 
;     106 					// pas sur le clavier utilis)
;     107 bit g_flag_char = 0;			// g_flag_char = 1 lorsqu'une touche est appuye
;     108 					// g_flag_char = 0 lorsqu'une touche a t relche
;     109 bit g_Sens_transfert = 0;		// Indique le sens de la communication  
;     110 					// g_Sens_transfert = 0 => C <--- clavier
;     111 			  		// g_Sens_transfert = 1 => C ---> clavier
;     112 unsigned int g_Trame_TX;                // ?
;     113 /* --------------------------------------------------------------------------------------
;     114 -----------------------------------------------------------------------------------------
;     115 type 		nom 				       		dsignation       
;     116 ------------------------------------------------------------------------------------------*/
;     117 char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur

	.DSEG
_display_buffer_ligne0:
	.BYTE 0x11
;     118 char display_buffer_ligne1[17]; 	       		// tampon ligne 1 de l'afficheur
_display_buffer_ligne1:
	.BYTE 0x11
;     119 unsigned char heures, minutes, secondes, secondes_1, dizieme; 	//stockage de l'heure
;     120 unsigned char Heure_ou_Date, H_J, mn_mois;
_mn_mois:
	.BYTE 0x1
;     121 unsigned int sec_annee;
_sec_annee:
	.BYTE 0x2
;     122 
;     123 enum Etat_Test {LedBP,LedTOR,Analog,Temperature,  	// Etats du graphe tests
;     124  	Reglage_HTR,Horloge,Buzzer,EEPROM,RS232Tx,MOT_PWM,REG_PWM, 
;     125  	CLAV_PC,REG_TST_CLAV102,TST_CLAV_102T } etat=LedBP, etat_1=LedTOR; 	 
_etat:
	.BYTE 0x1
_etat_1:
	.BYTE 0x1
;     126 // ----------------------------------------  page 2 ------------------------------------------------
;     127  
;     128 // Constantes en flash
;     129 const char menu[]	 = "  [ENTR]>Oui    ";      

	.CSEG
;     130 const char menu_BP[]     = "Test? BP->DEL   "; 
;     131 const char menu_TOR[] 	 = "Test? TOR->DEL  ";
;     132 const char menu_Analog[] = "Test? E_Analog  "; 
;     133 const char menu_Buzzer[] = "Test? Buzzer    "; 
;     134 const char menu_EEPROM[] = "Test? EEPROM    ";  
;     135 const char menu_RS232[]  = "Test? RS232Tx   "; 
;     136 const char menu_PWM[]    = "Test? PWMA      ";
;     137 const char menu_PC[]     = "Tst? Clav102 PC "; 
;     138 const char menu_ECHAP[]  = "[ECHAP]>Quitter ";
;     139 
;     140 // Caractres personnaliss placs dans la mmoire CGRAM du LCD  
;     141 const unsigned char flecheHaut[8] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    // @1 CGRAM
;     142 const unsigned char flecheBas[8] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     // @2 CGRAM       
;     143 
;     144 
;     145 // Prototypes des fonctions
;     146 int Led_BP_TOR(char entree);  // test des Leds et des BPs 
;     147 void Affiche_fleches(void);
;     148 
;     149 //-----------------------
;     150 // Programme principal
;     151 //-----------------------
;     152 void main(void)
;     153 { 
_main:
;     154 
;     155 // Declare your local variables here
;     156 // -----------------------------------------------------------------------------------------
;     157 //type 		nom 					dsignation  
;     158 // -----------------------------------------------------------------------------------------
;     159 char display_buffer[32]; 		// Tampon utilis lors de la lecture de la EEPROM
;     160 			 		// en page de 32 octets
;     161 unsigned char i, j;                     // Variable d'ordre gnrale
;     162 unsigned char BP;			// Reoit le code de la touche actionne
;     163 unsigned char jour,mois;
;     164 unsigned int  temp_n,annee;  
;     165 unsigned int  mesure,analogU, analogD, analogC; // Calcul de la ddp dlivre par le pot
;     166 unsigned char *Transm; 
;     167 unsigned char rcycl=0, rcycl_1=0;
;     168 // Coefficient pour le rglage du rapport cyclique du signal PWM
;     169 unsigned char alpha[11] = {0,25,51,76,102,127,153,178,204,229,255};   
;     170 
;     171 // Input/Output Ports initialization
;     172 // Port A
;     173 PORTA=0x3F; // Port A en entre avec rsistance de rappel
	SBIW R28,58
	LDI  R24,12
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x7B*2)
	LDI  R31,HIGH(_0x7B*2)
	RCALL __INITLOCB
;	display_buffer -> Y+26
;	i -> R16
;	j -> R17
;	BP -> R18
;	jour -> R19
;	mois -> R20
;	temp_n -> Y+24
;	annee -> Y+22
;	mesure -> Y+20
;	analogU -> Y+18
;	analogD -> Y+16
;	analogC -> Y+14
;	*Transm -> Y+12
;	rcycl -> R21
;	rcycl_1 -> Y+11
;	alpha -> Y+0
	LDI  R21,0
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;     174 DDRA=0x00;
	CLR  R30
	OUT  0x1A,R30
;     175 
;     176 // Port B
;     177 PORTB=0x00; // Port B en sortie
	RCALL SUBOPT_0x0
;     178 DDRB=0x1F;
	LDI  R30,LOW(31)
	OUT  0x17,R30
;     179 
;     180 // Port C
;     181 PORTC=0x00; // Port C en sortie
	CLR  R30
	OUT  0x15,R30
;     182 DDRC=0xFF;  // Partag entre le LCD et le Buzzer(PORTC.3)
	LDI  R30,LOW(255)
	OUT  0x14,R30
;     183 
;     184 // Port D initialization
;     185 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=Out Func6=In Func7=In
;     186 // State0=T State1=T State2=T State3=T State4=T State5=0 State6=T State7=T
;     187 PORTD=0x00;
	CLR  R30
	OUT  0x12,R30
;     188 DDRD=0x20;
	LDI  R30,LOW(32)
	OUT  0x11,R30
;     189 
;     190 // ----------------------------------------  page 3 ------------------------------------------------
;     191 
;     192 
;     193 // Timer/Counter 1 initialization
;     194 // Clock source: System Clock
;     195 // Clock value: 8000,000 kHz
;     196 // Mode: Ph. correct PWM top=00FFh
;     197 // OC1A output: Non-Inv.
;     198 // OC1B output: Discon.
;     199 // Noise Canceler: Off
;     200 // Input Capture on Falling Edge
;     201 TCCR1A=0x81;
	LDI  R30,LOW(129)
	OUT  0x2F,R30
;     202 TCCR1B=0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
;     203 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     204 TCNT1L=0x00;
	OUT  0x2C,R30
;     205 OCR1AH=0x00;
	OUT  0x2B,R30
;     206 OCR1AL=0x00;
	OUT  0x2A,R30
;     207 OCR1BH=0x00;
	OUT  0x29,R30
;     208 OCR1BL=0x00;
	OUT  0x28,R30
;     209 
;     210 // ADC initialization
;     211 // ADC Clock frequency: 62,500 kHz
;     212 // ADC Voltage Reference: AREF pin
;     213 // ADC High Speed Mode: Off
;     214 // ADC Auto Trigger Source: None
;     215 ADMUX=ADC_VREF_TYPE;
	OUT  0x7,R30
;     216 ADCSRA=0x87;
	LDI  R30,LOW(135)
	OUT  0x6,R30
;     217 SFIOR&=0xEF;
	IN   R30,0x30
	ANDI R30,0xEF
	OUT  0x30,R30
;     218 
;     219 // USART initialization
;     220 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     221 // USART Receiver: Off
;     222 // USART Transmitter: On
;     223 // USART Mode: Asynchronous
;     224 // USART Baud rate: 19200
;     225 UCSRA=0x00;
	CLR  R30
	OUT  0xB,R30
;     226 UCSRB=0x08;
	LDI  R30,LOW(8)
	OUT  0xA,R30
;     227 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     228 UBRRH=0x00;
	CLR  R30
	OUT  0x20,R30
;     229 UBRRL=0x19;
	LDI  R30,LOW(25)
	OUT  0x9,R30
;     230 
;     231 // I2C Bus initialization
;     232 i2c_init();
	RCALL _i2c_init
;     233 
;     234 // DS1621 Thermometer/Thermostat initialization
;     235 // tlow: 24C
;     236 // thigh: 55C
;     237 // Tout polarity: 0
;     238 ds1621_init(0,24,55,0);
	RCALL SUBOPT_0x1
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(55)
	RCALL SUBOPT_0x2
	RCALL _ds1621_init
;     239 
;     240 // PCF8583 Real Time Clock initialization
;     241 rtc_init(0,0);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1
	RCALL _rtc_init
;     242 
;     243 // External Interrupt(s) initialization
;     244 // INT0: On
;     245 // INT0 Mode: Falling Edge
;     246 // INT1: Off
;     247 // INT2: Off
;     248 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
;     249 MCUCR=0x02;
	RCALL SUBOPT_0x3
;     250 MCUCSR=0x00;
	OUT  0x34,R30
;     251 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     252 
;     253 // ----------------------------------------  page4 ------------------------------------------------
;     254 
;     255 
;     256 // LCD module initialization
;     257 lcd_init(16); 
	RCALL SUBOPT_0x4
	RCALL _lcd_init
;     258 
;     259 // Chargement initial de la mmoire CGRAM de l'afficheur avec les 
;     260 // caractres personaliss
;     261 for (i=0;i<8;i++)
	LDI  R16,LOW(0)
_0x7D:
	CPI  R16,8
	BRSH _0x7E
;     262 {
;     263 lcd_write_byte(Add_FlecheH_CGRAM + i, flecheHaut[i]); // @1 Caractre flche haut
	MOV  R30,R16
	SUBI R30,-LOW(64)
	ST   -Y,R30
	LDI  R26,LOW(_flecheHaut*2)
	LDI  R27,HIGH(_flecheHaut*2)
	RCALL SUBOPT_0x5
	LPM  R30,Z
	RCALL SUBOPT_0x6
;     264 lcd_write_byte(Add_FlecheB_CGRAM + i, flecheBas[i]); // @2 Caractre flche bas
	MOV  R30,R16
	SUBI R30,-LOW(72)
	ST   -Y,R30
	LDI  R26,LOW(_flecheBas*2)
	LDI  R27,HIGH(_flecheBas*2)
	RCALL SUBOPT_0x5
	LPM  R30,Z
	RCALL SUBOPT_0x6
;     265 }
	SUBI R16,-1
	RJMP _0x7D
_0x7E:
;     266 
;     267 sprintf(display_buffer_ligne0,"Test de la carte");
	RCALL SUBOPT_0x7
	__POINTW1FN _122,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     268 sprintf(display_buffer_ligne1,"******S.SI******");
	RCALL SUBOPT_0x9
	__POINTW1FN _122,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     269 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     270 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0xA
;     271 
;     272 // Global enable interrupts
;     273 #asm("sei")
	sei
;     274 
;     275 while (1)
_0x7F:
;     276       {		   // Dbut While(1)  
;     277        
;     278       BP = Lire_BP();
	RCALL SUBOPT_0xB
;     279       switch (etat)
	LDS  R30,_etat
;     280        {               // Dbut switch (etat)
;     281         case LedBP :   if (etat_1 != etat)
	CPI  R30,0
	BRNE _0x85
	RCALL SUBOPT_0xC
	BREQ _0x86
;     282                         { 
;     283                          sprintf(display_buffer_ligne0,menu_BP);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
	LDI  R24,0
	RCALL SUBOPT_0x8
;     284                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     285                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     286                          Affiche_fleches();
;     287                         } 
;     288                         switch(BP)
_0x86:
	RCALL SUBOPT_0x10
;     289         		    {
;     290         		     case INC : etat = LedTOR; break;
	BRNE _0x8A
	LDI  R30,LOW(1)
	RJMP _0x290
;     291         		     case DEC : etat = CLAV_PC; break;
_0x8A:
	CPI  R30,LOW(0x2F)
	BRNE _0x8B
	LDI  R30,LOW(11)
	RJMP _0x290
;     292         		     case ENTR: Led_BP_TOR(0); //test des BP
_0x8B:
	CPI  R30,LOW(0x3E)
	BRNE _0x8D
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x11
;     293        		      			sprintf(display_buffer_ligne0,menu_BP);
	RCALL SUBOPT_0xD
	LDI  R24,0
	RCALL SUBOPT_0x8
;     294                   			sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     295                      			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     296                      			Affiche_fleches();
;     297                              break;
	RJMP _0x89
;     298         		     default  : etat = LedBP;
_0x8D:
	CLR  R30
_0x290:
	STS  _etat,R30
;     299         		    }
_0x89:
;     300        			etat_1 = LedBP;
	CLR  R30
	STS  _etat_1,R30
;     301        		        
;     302         break;
	RJMP _0x84
;     303         
;     304         case LedTOR : if (etat_1 != etat)
_0x85:
	CPI  R30,LOW(0x1)
	BRNE _0x8E
	RCALL SUBOPT_0xC
	BREQ _0x8F
;     305                         { 
;     306                          sprintf(display_buffer_ligne0,menu_TOR);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x12
	LDI  R24,0
	RCALL SUBOPT_0x8
;     307                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     308                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     309                          Affiche_fleches();
;     310                         } 
;     311                         switch(BP)
_0x8F:
	RCALL SUBOPT_0x10
;     312         		    {
;     313         		     case INC : etat = Buzzer; break;
	BRNE _0x93
	LDI  R30,LOW(6)
	RJMP _0x291
;     314         		     case DEC : etat = LedBP; break;
_0x93:
	CPI  R30,LOW(0x2F)
	BRNE _0x94
	CLR  R30
	RJMP _0x291
;     315         		     case ENTR: Led_BP_TOR(1); // test des entres TOR
_0x94:
	CPI  R30,LOW(0x3E)
	BRNE _0x96
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x11
;     316        		      			sprintf(display_buffer_ligne0,menu_TOR);
	RCALL SUBOPT_0x12
	LDI  R24,0
	RCALL SUBOPT_0x8
;     317                   			sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     318                      			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     319                      			Affiche_fleches(); 
;     320                              break;
	RJMP _0x92
;     321         		     default  : etat = LedTOR;
_0x96:
	LDI  R30,LOW(1)
_0x291:
	STS  _etat,R30
;     322         		    }
_0x92:
;     323        			etat_1 = LedTOR;	
	LDI  R30,LOW(1)
	STS  _etat_1,R30
;     324         break;
	RJMP _0x84
;     325         
;     326         case Buzzer:	if (etat_1 != etat)
_0x8E:
	CPI  R30,LOW(0x6)
	BRNE _0x97
	RCALL SUBOPT_0xC
	BREQ _0x98
;     327                         { 
;     328                          sprintf(display_buffer_ligne0,menu_Buzzer);
	RCALL SUBOPT_0x7
	LDI  R30,LOW(_menu_Buzzer*2)
	LDI  R31,HIGH(_menu_Buzzer*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     329                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     330                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     331                          Affiche_fleches();
;     332                         } 
;     333         		switch(BP)
_0x98:
	RCALL SUBOPT_0x10
;     334         		    {
;     335         		     case INC : etat = Analog; break;
	BRNE _0x9C
	LDI  R30,LOW(2)
	RJMP _0x292
;     336         		     case DEC : etat = LedTOR; break;
_0x9C:
	CPI  R30,LOW(0x2F)
	BRNE _0x9E
	LDI  R30,LOW(1)
	RJMP _0x292
;     337         		     default  : etat = Buzzer;
_0x9E:
	LDI  R30,LOW(6)
_0x292:
	STS  _etat,R30
;     338         		    }
;     339        			PORTC.3 = !PINA.0;
	CLT
	SBIS 0x19,0
	SET
	IN   R30,0x15
	BLD  R30,3
	OUT  0x15,R30
;     340        			etat_1 = Buzzer;       		
	LDI  R30,LOW(6)
	STS  _etat_1,R30
;     341         break;  
	RJMP _0x84
;     342         
;     343         case Analog :  	if (etat_1 != etat)
_0x97:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0x9F
	RCALL SUBOPT_0xC
	BREQ _0xA0
;     344                         { 
;     345                          sprintf(display_buffer_ligne0,menu_Analog);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x14
	LDI  R24,0
	RCALL SUBOPT_0x8
;     346                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     347                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     348                          Affiche_fleches();
;     349                         } 
;     350                         switch(BP)
_0xA0:
	RCALL SUBOPT_0x10
;     351                          {
;     352         		     case INC : etat = Temperature; break;
	BRNE _0xA4
	LDI  R30,LOW(3)
	RJMP _0x293
;     353         		     case DEC : etat = Buzzer; break;
_0xA4:
	CPI  R30,LOW(0x2F)
	BRNE _0xA5
	LDI  R30,LOW(6)
	RJMP _0x293
;     354         		     case ENTR: sprintf(display_buffer_ligne1,menu_ECHAP);
_0xA5:
	CPI  R30,LOW(0x3E)
	BREQ PC+2
	RJMP _0xAA
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x15
	LDI  R24,0
	RCALL SUBOPT_0x8
;     355        		       			          
;     356        		      			while (BP != ECHAP) 
_0xA7:
	CPI  R18,59
	BRNE PC+2
	RJMP _0xA9
;     357        		       			{ 
;     358        		       			 BP = Lire_BP();
	RCALL SUBOPT_0xB
;     359        		       			 delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0xA
;     360        		       			 mesure = (read_adc(6)/4); // Mesure et calcul de la ddp
	RCALL SUBOPT_0x16
	RCALL _read_adc
	RCALL __LSRW2
	STD  Y+20,R30
	STD  Y+20+1,R31
;     361        		       			 analogU = ((mesure*5)/255);
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	STD  Y+18,R30
	STD  Y+18+1,R31
;     362        		       			 analogD = ((10*((mesure - (analogU*255)/5))*5)/255);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x18
	STD  Y+16,R30
	STD  Y+16+1,R31
;     363        		       			 analogC = ((100*(mesure - (analogU*255)/5 -(analogD*255)/50)*5)/255);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	PUSH R31
	PUSH R30
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	RCALL SUBOPT_0x17
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __DIVW21U
	POP  R26
	POP  R27
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x18
	STD  Y+14,R30
	STD  Y+14+1,R31
;     364        		       			 sprintf(display_buffer_ligne0,"  DDP = %-u.%-u%-uV",analogU, analogD, analogC);
	RCALL SUBOPT_0x7
	__POINTW1FN _122,34
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	RCALL SUBOPT_0x1C
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x1C
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	RCALL SUBOPT_0x1C
	LDI  R24,12
	RCALL SUBOPT_0x1D
;     365        		       			 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     366        		       			}
	RJMP _0xA7
_0xA9:
;     367        		       			 sprintf(display_buffer_ligne0,menu_Analog);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x14
	LDI  R24,0
	RCALL SUBOPT_0x8
;     368                     			 sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     369                         		 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);  
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     370        		             break;
	RJMP _0xA3
;     371        			     default  : etat = Analog;
_0xAA:
	LDI  R30,LOW(2)
_0x293:
	STS  _etat,R30
;     372        			   }
_0xA3:
;     373        			etat_1 = Analog;       		
	LDI  R30,LOW(2)
	STS  _etat_1,R30
;     374         break;
	RJMP _0x84
;     375         
;     376         case Temperature : temp_n = ds1621_temperature_10(0); // Affichage de la temprature toutes les secondes
_0x9F:
	CPI  R30,LOW(0x3)
	BRNE _0xAB
	RCALL SUBOPT_0x1
	RCALL _ds1621_temperature_10
	STD  Y+24,R30
	STD  Y+24+1,R31
;     377         	           rtc_get_time(adresse_HTR,&heures,&minutes,&secondes,&dizieme);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1E
;     378         	       	   if ((etat_1 != etat) || (secondes_1 != secondes))
	BRNE _0xAD
	CP   R10,R11
	BREQ _0xAC
_0xAD:
;     379         		    {  
;     380         		      sprintf(display_buffer_ligne0,"Capteur DS1621  ");
	RCALL SUBOPT_0x7
	__POINTW1FN _122,54
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     381         		      sprintf(display_buffer_ligne1,"Temp. = %-i.%-u%-cC",temp_n/10,abs(temp_n%10),0xdf);
	RCALL SUBOPT_0x9
	__POINTW1FN _122,71
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+28
	LDD  R27,Y+28+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	RCALL SUBOPT_0x1C
	LDD  R26,Y+32
	LDD  R27,Y+32+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	ST   -Y,R31
	ST   -Y,R30
	RCALL _abs
	RCALL SUBOPT_0x1C
	__GETD1N 0xDF
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL SUBOPT_0x1D
;     382         		      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     383         	              secondes_1 = secondes;   
	MOV  R11,R10
;     384         	              Affiche_fleches();
	RCALL _Affiche_fleches
;     385         	            }
;     386         	           switch(BP)
_0xAC:
	RCALL SUBOPT_0x10
;     387         		    {
;     388         		     case INC : etat = EEPROM; break;
	BRNE _0xB2
	LDI  R30,LOW(7)
	RJMP _0x294
;     389         		     case DEC : etat = Analog; break;
_0xB2:
	CPI  R30,LOW(0x2F)
	BRNE _0xB4
	LDI  R30,LOW(2)
	RJMP _0x294
;     390         		     default  : etat = Temperature;
_0xB4:
	LDI  R30,LOW(3)
_0x294:
	STS  _etat,R30
;     391         		    }
;     392         		   etat_1 = Temperature;
	LDI  R30,LOW(3)
	STS  _etat_1,R30
;     393         break;
	RJMP _0x84
;     394         
;     395         case EEPROM:	if (etat_1 != etat)
_0xAB:
	CPI  R30,LOW(0x7)
	BRNE _0xB5
	RCALL SUBOPT_0xC
	BREQ _0xB6
;     396                         { 
;     397                          sprintf(display_buffer_ligne0,menu_EEPROM);
	RCALL SUBOPT_0x7
	LDI  R30,LOW(_menu_EEPROM*2)
	LDI  R31,HIGH(_menu_EEPROM*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     398                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     399                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     400                          Affiche_fleches(); 
;     401                         }  
;     402                         switch(BP)
_0xB6:
	RCALL SUBOPT_0x10
;     403         		    {
;     404         		     case INC : etat = Horloge; break;
	BRNE _0xBA
	LDI  R30,LOW(5)
	RJMP _0x295
;     405         		     case DEC : etat = Temperature; break;
_0xBA:
	CPI  R30,LOW(0x2F)
	BRNE _0xBB
	LDI  R30,LOW(3)
	RJMP _0x295
;     406         		     case ENTR: j=0;
_0xBB:
	CPI  R30,LOW(0x3E)
	BRNE _0xC0
	LDI  R17,LOW(0)
;     407        		      		        for (i=0;i<8;i++)
	LDI  R16,LOW(0)
_0xBE:
	CPI  R16,8
	BRSH _0xBF
;     408 					 { 
;     409  					   lcd_clear();
	RCALL _lcd_clear
;     410  					   eeprom_page_read(0xae,j,display_buffer); // EEPROM  l'@AE
	LDI  R30,LOW(174)
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	RCALL _eeprom_page_read
;     411  					   lcd_puts(display_buffer);
	MOVW R30,R28
	ADIW R30,26
	RCALL SUBOPT_0x1F
;     412  					   delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0xA
;     413  					   j=j+32;
	SUBI R17,-LOW(32)
;     414 					 }
	SUBI R16,-1
	RJMP _0xBE
_0xBF:
;     415         		     default  : etat = EEPROM;
_0xC0:
	LDI  R30,LOW(7)
_0x295:
	STS  _etat,R30
;     416         		    }
;     417        			etat_1 = EEPROM;       		
	LDI  R30,LOW(7)
	STS  _etat_1,R30
;     418         break;            
	RJMP _0x84
;     419         
;     420         case Horloge :  rtc_get_time(adresse_HTR,&heures,&minutes,&secondes,&dizieme);    
_0xB5:
	CPI  R30,LOW(0x5)
	BREQ PC+2
	RJMP _0xC1
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1E
;     421         		if ((etat_1 != etat) || (secondes_1 != secondes))
	BRNE _0xC3
	CP   R10,R11
	BREQ _0xC2
_0xC3:
;     422         		{
;     423         		 rtc_get_date(adresse_HTR,&jour,&mois,&annee);
	RCALL SUBOPT_0x1
	LDI  R30,LOW(19)
	LDI  R31,HIGH(19)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,27
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_date
;     424         		 sprintf(display_buffer_ligne0," %-u / %-u / %-i",jour,mois,annee);
	RCALL SUBOPT_0x7
	__POINTW1FN _122,91
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R19
	RCALL SUBOPT_0x20
	MOV  R30,R20
	RCALL SUBOPT_0x20
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	RCALL SUBOPT_0x1C
	LDI  R24,12
	RCALL SUBOPT_0x21
;     425         		 sprintf(display_buffer_ligne1,"%-uh / %-umn / %-us ",heures, minutes, secondes);
	RCALL SUBOPT_0x9
	__POINTW1FN _122,108
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x24
	LDI  R24,12
	RCALL SUBOPT_0x1D
;     426         		 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     427         	         secondes_1 = secondes;
	MOV  R11,R10
;     428         	         Affiche_fleches();
	RCALL _Affiche_fleches
;     429         	        }
;     430         		switch(BP)
_0xC2:
	RCALL SUBOPT_0x10
;     431         		{
;     432         		 case INC : etat = RS232Tx; break;
	BRNE _0xC8
	LDI  R30,LOW(8)
	RJMP _0x296
;     433         		 case DEC : etat = EEPROM; break;
_0xC8:
	CPI  R30,LOW(0x2F)
	BRNE _0xC9
	LDI  R30,LOW(7)
	RJMP _0x296
;     434         		 case ENTR : etat = Reglage_HTR; break; 
_0xC9:
	CPI  R30,LOW(0x3E)
	BRNE _0xCB
	LDI  R30,LOW(4)
	RJMP _0x296
;     435         		 default : etat = Horloge;
_0xCB:
	LDI  R30,LOW(5)
_0x296:
	STS  _etat,R30
;     436         		}
;     437         		etat_1 = Horloge;
	LDI  R30,LOW(5)
	STS  _etat_1,R30
;     438         break;     
	RJMP _0x84
;     439         
;     440         case Reglage_HTR : if (etat_1 != etat)
_0xC1:
	CPI  R30,LOW(0x4)
	BRNE _0xCC
	RCALL SUBOPT_0xC
	BREQ _0xCD
;     441                            {
;     442         	            sprintf(display_buffer_ligne0,"  Reglage HTR");
	RCALL SUBOPT_0x7
	__POINTW1FN _122,129
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     443         	            sprintf(display_buffer_ligne1,"SET>H ETR>Date ");
	RCALL SUBOPT_0x9
	__POINTW1FN _122,143
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     444         	            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     445         		   }   
;     446         		               
;     447         	          switch(BP)
_0xCD:
	MOV  R30,R18
;     448         		   {
;     449         		    case SET   : Heure_ou_Date = 0;
	CPI  R30,LOW(0x3D)
	BRNE _0xD1
	CLR  R13
;     450         		  	        H_J = 12;
	LDI  R30,LOW(12)
	MOV  R14,R30
;     451         		  	        mn_mois = 30;
	LDI  R30,LOW(30)
	STS  _mn_mois,R30
;     452         		  	        sec_annee = 0;
	CLR  R30
	STS  _sec_annee,R30
	STS  _sec_annee+1,R30
;     453         		  	        regle_HTR(adresse_HTR,Heure_ou_Date,H_J,mn_mois,sec_annee);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x25
;     454         		  	        etat = Horloge;
	RJMP _0x297
;     455         		    break;
;     456         		 
;     457         		    case ENTR : Heure_ou_Date = 1;
_0xD1:
	CPI  R30,LOW(0x3E)
	BRNE _0xD3
	LDI  R30,LOW(1)
	MOV  R13,R30
;     458         		  	         H_J = 15;
	LDI  R30,LOW(15)
	MOV  R14,R30
;     459         		  	         mn_mois = 6;
	LDI  R30,LOW(6)
	STS  _mn_mois,R30
;     460         		  	         sec_annee = 2008;
	LDI  R30,LOW(2008)
	LDI  R31,HIGH(2008)
	STS  _sec_annee,R30
	STS  _sec_annee+1,R31
;     461         		  	         regle_HTR(adresse_HTR,Heure_ou_Date,H_J,mn_mois,sec_annee);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x25
;     462         		  	         etat = Horloge;
	RJMP _0x297
;     463         		    break;
;     464         		 
;     465         		    default:     etat = Reglage_HTR;
_0xD3:
	LDI  R30,LOW(4)
_0x297:
	STS  _etat,R30
;     466         		   } 
;     467         	          etat_1 = Reglage_HTR;
	LDI  R30,LOW(4)
	STS  _etat_1,R30
;     468         break; 
	RJMP _0x84
;     469         
;     470         case RS232Tx:	if (etat_1 != etat)
_0xCC:
	CPI  R30,LOW(0x8)
	BRNE _0xD4
	RCALL SUBOPT_0xC
	BREQ _0xD5
;     471                         { 
;     472                          sprintf(display_buffer_ligne0,menu_RS232);
	RCALL SUBOPT_0x7
	LDI  R30,LOW(_menu_RS232*2)
	LDI  R31,HIGH(_menu_RS232*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     473                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     474                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     475                          Affiche_fleches(); 
;     476                         }  
;     477                         switch(BP)
_0xD5:
	RCALL SUBOPT_0x10
;     478         		    {
;     479         		     case INC : etat = MOT_PWM; break;
	BRNE _0xD9
	LDI  R30,LOW(9)
	RJMP _0x298
;     480         		     case DEC : etat = Horloge; break;
_0xD9:
	CPI  R30,LOW(0x2F)
	BRNE _0xDA
	LDI  R30,LOW(5)
	RJMP _0x298
;     481         		     case ENTR: rtc_get_time(adresse_HTR,&heures,&minutes,&secondes,&dizieme);
_0xDA:
	CPI  R30,LOW(0x3E)
	BRNE _0xDC
	RCALL SUBOPT_0x1
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_time
;     482         		     sprintf(Transm,"%u/%u/%u",heures, minutes, secondes);
	RCALL SUBOPT_0x26
	__POINTW1FN _122,159
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x24
	LDI  R24,12
	RCALL SUBOPT_0x21
;     483         		     puts(Transm); 
	RCALL SUBOPT_0x26
	RCALL _puts
;     484         		     break;       
	RJMP _0xD8
;     485         		     default  : etat = RS232Tx;
_0xDC:
	LDI  R30,LOW(8)
_0x298:
	STS  _etat,R30
;     486         		    }
_0xD8:
;     487        			etat_1 = RS232Tx;       		
	LDI  R30,LOW(8)
	STS  _etat_1,R30
;     488         break; 
	RJMP _0x84
;     489         
;     490         case MOT_PWM :	if (etat_1 != etat)
_0xD4:
	CPI  R30,LOW(0x9)
	BRNE _0xDD
	RCALL SUBOPT_0xC
	BREQ _0xDE
;     491                         { 
;     492                          sprintf(display_buffer_ligne0,menu_PWM);
	RCALL SUBOPT_0x7
	LDI  R30,LOW(_menu_PWM*2)
	LDI  R31,HIGH(_menu_PWM*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     493                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     494                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     495                          Affiche_fleches(); 
;     496                         }  
;     497                         switch(BP)
_0xDE:
	RCALL SUBOPT_0x10
;     498         		    {
;     499         		     case INC : etat = CLAV_PC; break;
	BRNE _0xE2
	LDI  R30,LOW(11)
	RJMP _0x299
;     500         		     case DEC : etat = RS232Tx; break;
_0xE2:
	CPI  R30,LOW(0x2F)
	BRNE _0xE3
	LDI  R30,LOW(8)
	RJMP _0x299
;     501         		     case ENTR: etat = REG_PWM; break; 
_0xE3:
	CPI  R30,LOW(0x3E)
	BRNE _0xE5
	LDI  R30,LOW(10)
	RJMP _0x299
;     502         		     default  : etat = MOT_PWM;
_0xE5:
	LDI  R30,LOW(9)
_0x299:
	STS  _etat,R30
;     503         		    }
;     504        			etat_1 = MOT_PWM;       
	LDI  R30,LOW(9)
	STS  _etat_1,R30
;     505         break;
	RJMP _0x84
;     506         
;     507         case REG_PWM :  if ((etat_1 != etat)|| (rcycl_1 != rcycl))
_0xDD:
	CPI  R30,LOW(0xA)
	BREQ PC+2
	RJMP _0xE6
	RCALL SUBOPT_0xC
	BRNE _0xE8
	LDD  R26,Y+11
	CP   R21,R26
	BREQ _0xE7
_0xE8:
;     508        			  {
;     509        		   	    sprintf(display_buffer_ligne0,"Rap. cycl = %-u%%",rcycl);
	RCALL SUBOPT_0x7
	__POINTW1FN _122,168
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R21
	RCALL SUBOPT_0x20
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
;     510        		            sprintf(display_buffer_ligne1,"INC>+ DEC>- ESc>");
	RCALL SUBOPT_0x9
	__POINTW1FN _122,186
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     511        		            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     512        		            rcycl_1 = rcycl; 
	STD  Y+11,R21
;     513 			  }
;     514 		        switch(BP)
_0xE7:
	RCALL SUBOPT_0x10
;     515 			      {
;     516 				case INC: if (rcycl < 90) rcycl = rcycl+10; else rcycl = 100; break;
	BRNE _0xED
	CPI  R21,90
	BRSH _0xEE
	SUBI R21,-LOW(10)
	RJMP _0xEF
_0xEE:
	LDI  R21,LOW(100)
_0xEF:
	RJMP _0xEC
;     517 				case DEC: if (rcycl > 10) rcycl = rcycl-10; else rcycl = 0; break;
_0xED:
	CPI  R30,LOW(0x2F)
	BRNE _0xF0
	LDI  R30,LOW(10)
	CP   R30,R21
	BRSH _0xF1
	SUBI R21,LOW(10)
	RJMP _0xF2
_0xF1:
	LDI  R21,LOW(0)
_0xF2:
	RJMP _0xEC
;     518 				case ECHAP : rcycl = 0; etat = MOT_PWM; break;
_0xF0:
	CPI  R30,LOW(0x3B)
	BRNE _0xF4
	LDI  R21,LOW(0)
	LDI  R30,LOW(9)
	RJMP _0x29A
;     519 				default: etat = REG_PWM;
_0xF4:
	LDI  R30,LOW(10)
_0x29A:
	STS  _etat,R30
;     520                               }
_0xEC:
;     521 			OCR1AL=alpha[rcycl/10];
	MOV  R26,R21
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	CLR  R31
	MOVW R26,R28
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	OUT  0x2A,R30
;     522          		etat_1 = REG_PWM ;      		      
	LDI  R30,LOW(10)
	STS  _etat_1,R30
;     523         break;
	RJMP _0x84
;     524         
;     525         case CLAV_PC :	if (etat_1 != etat)
_0xE6:
	CPI  R30,LOW(0xB)
	BRNE _0xF5
	RCALL SUBOPT_0xC
	BREQ _0xF6
;     526                         { 
;     527                          sprintf(display_buffer_ligne0,menu_PC);
	RCALL SUBOPT_0x7
	LDI  R30,LOW(_menu_PC*2)
	LDI  R31,HIGH(_menu_PC*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     528                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xE
	LDI  R24,0
	RCALL SUBOPT_0x8
;     529                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xF
;     530                          Affiche_fleches(); 
;     531                         }  
;     532                         switch(BP)
_0xF6:
	RCALL SUBOPT_0x10
;     533         		    {
;     534         		     case INC : etat = LedBP; break;
	BRNE _0xFA
	CLR  R30
	RJMP _0x29B
;     535         		     case DEC : etat = MOT_PWM; break;
_0xFA:
	CPI  R30,LOW(0x2F)
	BRNE _0xFB
	LDI  R30,LOW(9)
	RJMP _0x29B
;     536         		     case ENTR: etat = REG_TST_CLAV102; break; 
_0xFB:
	CPI  R30,LOW(0x3E)
	BRNE _0xFD
	LDI  R30,LOW(12)
	RJMP _0x29B
;     537         		     default  : etat = CLAV_PC;
_0xFD:
	LDI  R30,LOW(11)
_0x29B:
	STS  _etat,R30
;     538         		    }
;     539        			etat_1 = CLAV_PC;       
	LDI  R30,LOW(11)
	STS  _etat_1,R30
;     540         break; 
	RJMP _0x84
;     541         
;     542         case REG_TST_CLAV102 :	if (etat_1 != etat)
_0xF5:
	CPI  R30,LOW(0xC)
	BRNE _0xFE
	RCALL SUBOPT_0xC
	BREQ _0xFF
;     543                         { 
;     544                          sprintf(display_buffer_ligne0,"Caval PAO 1-2 OK");
	RCALL SUBOPT_0x7
	__POINTW1FN _122,203
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     545                          sprintf(display_buffer_ligne1,menu_ECHAP);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x15
	LDI  R24,0
	RCALL SUBOPT_0x8
;     546                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     547                         }  
;     548                         switch(BP)
_0xFF:
	MOV  R30,R18
;     549         		    {
;     550         		     case OK : etat = TST_CLAV_102T; break;
	CPI  R30,LOW(0x37)
	BRNE _0x103
	LDI  R30,LOW(13)
	RJMP _0x29C
;     551         		     case ECHAP: etat = CLAV_PC; break; 
_0x103:
	CPI  R30,LOW(0x3B)
	BRNE _0x105
	LDI  R30,LOW(11)
	RJMP _0x29C
;     552         		     default  : etat = REG_TST_CLAV102;
_0x105:
	LDI  R30,LOW(12)
_0x29C:
	STS  _etat,R30
;     553         		    }
;     554        			etat_1 = REG_TST_CLAV102;       
	LDI  R30,LOW(12)
	STS  _etat_1,R30
;     555         break; 
	RJMP _0x84
;     556         
;     557         case TST_CLAV_102T : if (etat_1 != etat)
_0xFE:
	CPI  R30,LOW(0xD)
	BRNE _0x84
	RCALL SUBOPT_0xC
	BREQ _0x107
;     558                        {
;     559                         sprintf(display_buffer_ligne0,"                ");
	RCALL SUBOPT_0x7
	__POINTW1FN _122,220
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     560                     	sprintf(display_buffer_ligne1,menu_ECHAP);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x15
	LDI  R24,0
	RCALL SUBOPT_0x8
;     561                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x27
;     562                     	lcd_gotoxy(0,0);_lcd_write_data(displayOn3); i =0; 
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x28
	LDI  R16,LOW(0)
;     563                        }
;     564                       
;     565                       if (g_flag_char == VRAI)
_0x107:
	SBRS R2,1
	RJMP _0x108
;     566                        { 
;     567                          if (i<16)
	CPI  R16,16
	BRSH _0x109
;     568                                {
;     569                          	lcd_putchar(g_key_ASCII);
	ST   -Y,R5
	RCALL _lcd_putchar
;     570                          	i++;
	SUBI R16,-1
;     571                                } 
;     572                          else 
	RJMP _0x10A
_0x109:
;     573                          	{ 
;     574                          	  sprintf(display_buffer_ligne0,"                ");
	RCALL SUBOPT_0x7
	__POINTW1FN _122,237
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     575                        		  sprintf(display_buffer_ligne1,menu_ECHAP);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x15
	LDI  R24,0
	RCALL SUBOPT_0x8
;     576                     		  Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x27
;     577                     		  lcd_gotoxy(0,0);_lcd_write_data(displayOn3); i = 0;      
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x28
	LDI  R16,LOW(0)
;     578                          	}
_0x10A:
;     579                          g_flag_char = FAUX;
	CLT
	BLD  R2,1
;     580                        }  
;     581                        
;     582                       switch(BP)
_0x108:
	MOV  R30,R18
;     583         		    {
;     584         		     case ECHAP: etat = CLAV_PC; break; 
	CPI  R30,LOW(0x3B)
	BRNE _0x10F
	LDI  R30,LOW(11)
	RJMP _0x29D
;     585         		     default  : etat = TST_CLAV_102T;
_0x10F:
	LDI  R30,LOW(13)
_0x29D:
	STS  _etat,R30
;     586         		    } 
;     587        		    etat_1 = TST_CLAV_102T;
	LDI  R30,LOW(13)
	STS  _etat_1,R30
;     588        break;           
;     589         
;     590        }; // Fin switch(etat)
_0x84:
;     591       }  // Fin while(1)    
	RJMP _0x7F
;     592 } // Fin main()
	ADIW R28,58
_0x110:
	RJMP _0x110
;     593 
;     594 //===================================================================
;     595 // Sous-programmes
;     596 //-------------------------------------------------------------------
;     597 void Affiche_fleches(void)
;     598 {
_Affiche_fleches:
;     599 lcd_gotoxy(15,0);	// Affichage flecheHaut
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
;     600 		         lcd_putchar(Caractere_FlecheH);	
	RCALL SUBOPT_0x1
	RCALL _lcd_putchar
;     601 			 lcd_gotoxy(15,1);	// Affichage flecheBas
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x29
	RCALL _lcd_gotoxy
;     602 			 lcd_putchar(Caractere_FlecheB);
	RCALL SUBOPT_0x13
	RCALL _lcd_putchar
;     603 }
	RET
;     604 
;     605 // -------------------------------------------------------------------
;     606 
;     607 int Led_BP_TOR(char entree)
;     608 {
_Led_BP_TOR:
;     609   unsigned char BP, Affich=1, sortir=0;
;     610   
;     611   if (entree==0)
	RCALL __SAVELOCR3
;	entree -> Y+3
;	BP -> R16
;	Affich -> R17
;	sortir -> R18
	LDI  R17,1
	LDI  R18,0
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0x113
;     612        {
;     613         sprintf(display_buffer_ligne1,"Sortir = 2xECHAP");
	RCALL SUBOPT_0x9
	__POINTW1FN _274,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x29E
;     614     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
;     615        }
;     616         else 
_0x113:
;     617        {
;     618         sprintf(display_buffer_ligne1,"Sortir = 2xPA2  ");
	RCALL SUBOPT_0x9
	__POINTW1FN _274,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
_0x29E:
	RCALL _sprintf
	ADIW R28,4
;     619        	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     620        }
;     621   
;     622   while(sortir<2)
_0x115:
	CPI  R18,2
	BRLO PC+2
	RJMP _0x117
;     623   {
;     624    BP=Lire_BP();
	RCALL SUBOPT_0x2A
;     625    switch (BP)
	RCALL SUBOPT_0x2B
;     626       {
;     627        case INC: PORTB = 0x1F;
	BRNE _0x11B
	LDI  R30,LOW(31)
	OUT  0x18,R30
;     628        		 sprintf(display_buffer_ligne0,"   PA5 -> ALL   ");
	RCALL SUBOPT_0x7
	__POINTW1FN _274,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     629        		 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     630                  Affich = 1;
	LDI  R17,LOW(1)
;     631                  if (sortir=1) sortir=0;
	RCALL SUBOPT_0x2C
	BREQ _0x11C
	LDI  R18,LOW(0)
;     632        break; 
_0x11C:
	RJMP _0x11A
;     633        
;     634        case DEC: PORTB.4 = 1;
_0x11B:
	CPI  R30,LOW(0x2F)
	BRNE _0x11D
	SBI  0x18,4
;     635        		 sprintf(display_buffer_ligne0,"   PA4 -> PB4   ");
	RCALL SUBOPT_0x7
	__POINTW1FN _274,51
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     636        	       	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     637                  Affich = 1;
	LDI  R17,LOW(1)
;     638                  if (sortir=1) sortir=0;
	RCALL SUBOPT_0x2C
	BREQ _0x11E
	LDI  R18,LOW(0)
;     639        	break;
_0x11E:
	RJMP _0x11A
;     640        	 
;     641      	case OK: PORTB.3 = 1;
_0x11D:
	CPI  R30,LOW(0x37)
	BRNE _0x11F
	SBI  0x18,3
;     642      		 sprintf(display_buffer_ligne0,"   PA3 -> PB3   ");
	RCALL SUBOPT_0x7
	__POINTW1FN _274,68
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     643        	       	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     644                  Affich = 1; 
	LDI  R17,LOW(1)
;     645                  if (sortir=1) sortir=0;
	RCALL SUBOPT_0x2C
	BREQ _0x120
	LDI  R18,LOW(0)
;     646        	break;
_0x120:
	RJMP _0x11A
;     647        	  
;     648       	case SET:PORTB.1 = 1;
_0x11F:
	CPI  R30,LOW(0x3D)
	BRNE _0x121
	SBI  0x18,1
;     649       		 sprintf(display_buffer_ligne0,"   PA1 -> PB1   ");
	RCALL SUBOPT_0x7
	__POINTW1FN _274,85
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     650         	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     651                  Affich = 1;
	LDI  R17,LOW(1)
;     652                  if (sortir=1) sortir=0;
	RCALL SUBOPT_0x2C
	BREQ _0x122
	LDI  R18,LOW(0)
;     653        	break;
_0x122:
	RJMP _0x11A
;     654        	   
;     655       	case ECHAP: PORTB.2 = 1;
_0x121:
	CPI  R30,LOW(0x3B)
	BRNE _0x123
	SBI  0x18,2
;     656       	            sprintf(display_buffer_ligne0,"   PA2 -> PB2   ");
	RCALL SUBOPT_0x7
	__POINTW1FN _274,102
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     657        	       	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     658        		    Affich = 1;
	LDI  R17,LOW(1)
;     659        		    sortir = sortir + 1;
	SUBI R18,-LOW(1)
;     660        	break;
	RJMP _0x11A
;     661        	
;     662        	case ENTR: PORTB.0 = 1;
_0x123:
	CPI  R30,LOW(0x3E)
	BRNE _0x124
	SBI  0x18,0
;     663        		    sprintf(display_buffer_ligne0,"   PA0 -> PB0   ");
	RCALL SUBOPT_0x7
	__POINTW1FN _274,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     664        	       	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     665                     Affich = 1;
	LDI  R17,LOW(1)
;     666                     if (sortir=1) sortir=0;
	RCALL SUBOPT_0x2C
	BREQ _0x125
	LDI  R18,LOW(0)
;     667        	break;
_0x125:
	RJMP _0x11A
;     668        	     
;     669       	case 0xff: PORTB = 0;
_0x124:
	CPI  R30,LOW(0xFF)
	BRNE _0x11A
	RCALL SUBOPT_0x0
;     670       	           if ((Affich == 1)&&(entree==0))
	CPI  R17,1
	BRNE _0x128
	LDD  R26,Y+3
	CPI  R26,LOW(0x0)
	BREQ _0x129
_0x128:
	RJMP _0x127
_0x129:
;     671        	  	    {
;     672        	  	      sprintf(display_buffer_ligne0," Test BPx->DELx");
	RCALL SUBOPT_0x7
	__POINTW1FN _274,136
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     673        	       	      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     674        	       	    }
;     675        	       	    else if  ((Affich == 1)&&(entree==1))
	RJMP _0x12A
_0x127:
	CPI  R17,1
	BRNE _0x12C
	LDD  R26,Y+3
	CPI  R26,LOW(0x1)
	BREQ _0x12D
_0x12C:
	RJMP _0x12B
_0x12D:
;     676        	       	    {
;     677        	  	      sprintf(display_buffer_ligne0,"Test TORx->DELx");
	RCALL SUBOPT_0x7
	__POINTW1FN _274,152
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
;     678        	       	      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	RCALL _Affiche_LCD
;     679        	       	    }
;     680        	       	    Affich = 0; 
_0x12B:
_0x12A:
	LDI  R17,LOW(0)
;     681        	       	    
;     682        	break;
;     683        }
_0x11A:
;     684   }
	RJMP _0x115
_0x117:
;     685 PORTB = 0;   
	RCALL SUBOPT_0x0
;     686 return 0;
	CLR  R30
	CLR  R31
	RCALL __LOADLOCR3
	ADIW R28,4
	RET
;     687 }
;     688 
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	put:
	RCALL SUBOPT_0x2D
	SBIW R30,0
	BREQ _0x164
	RCALL SUBOPT_0x2D
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x165
_0x164:
	RCALL SUBOPT_0x2E
	RCALL _putchar
_0x165:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x167:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x169
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x16D
	CPI  R19,37
	BRNE _0x16E
	LDI  R16,LOW(1)
	RJMP _0x16F
_0x16E:
	RCALL SUBOPT_0x2F
_0x16F:
	RJMP _0x16C
_0x16D:
	CPI  R30,LOW(0x1)
	BRNE _0x170
	CPI  R19,37
	BRNE _0x171
	RCALL SUBOPT_0x2F
	LDI  R16,LOW(0)
	RJMP _0x16C
_0x171:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x172
	LDI  R17,LOW(1)
	RJMP _0x16C
_0x172:
	CPI  R19,43
	BRNE _0x173
	LDI  R21,LOW(43)
	RJMP _0x16C
_0x173:
	CPI  R19,32
	BRNE _0x174
	LDI  R21,LOW(32)
	RJMP _0x16C
_0x174:
	RJMP _0x175
_0x170:
	CPI  R30,LOW(0x2)
	BRNE _0x176
_0x175:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x177
	ORI  R17,LOW(128)
	RJMP _0x16C
_0x177:
	RJMP _0x178
_0x176:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x16C
_0x178:
	CPI  R19,48
	BRLO _0x17B
	CPI  R19,58
	BRLO _0x17C
_0x17B:
	RJMP _0x17A
_0x17C:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x16C
_0x17A:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x180
	RCALL SUBOPT_0x30
	LD   R30,X
	RCALL SUBOPT_0x31
	RJMP _0x181
_0x180:
	CPI  R30,LOW(0x73)
	BRNE _0x183
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x32
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x184
_0x183:
	CPI  R30,LOW(0x70)
	BRNE _0x186
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x32
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x184:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x187
_0x186:
	CPI  R30,LOW(0x64)
	BREQ _0x18A
	CPI  R30,LOW(0x69)
	BRNE _0x18B
_0x18A:
	ORI  R17,LOW(4)
	RJMP _0x18C
_0x18B:
	CPI  R30,LOW(0x75)
	BRNE _0x18D
_0x18C:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x18E
_0x18D:
	CPI  R30,LOW(0x58)
	BRNE _0x190
	ORI  R17,LOW(8)
	RJMP _0x191
_0x190:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x1BF
_0x191:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x18E:
	SBRS R17,2
	RJMP _0x193
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x33
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x194
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x194:
	CPI  R21,0
	BREQ _0x195
	SUBI R16,-LOW(1)
	RJMP _0x196
_0x195:
	ANDI R17,LOW(251)
_0x196:
	RJMP _0x197
_0x193:
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x33
_0x197:
_0x187:
	SBRC R17,0
	RJMP _0x198
_0x199:
	CP   R16,R20
	BRSH _0x19B
	SBRS R17,7
	RJMP _0x19C
	SBRS R17,2
	RJMP _0x19D
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x19E
_0x19D:
	LDI  R19,LOW(48)
_0x19E:
	RJMP _0x19F
_0x19C:
	LDI  R19,LOW(32)
_0x19F:
	RCALL SUBOPT_0x2F
	SUBI R20,LOW(1)
	RJMP _0x199
_0x19B:
_0x198:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x1A0
_0x1A1:
	CPI  R18,0
	BREQ _0x1A3
	SBRS R17,3
	RJMP _0x1A4
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x29F
_0x1A4:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x29F:
	ST   -Y,R30
	RCALL SUBOPT_0x34
	CPI  R20,0
	BREQ _0x1A6
	SUBI R20,LOW(1)
_0x1A6:
	SUBI R18,LOW(1)
	RJMP _0x1A1
_0x1A3:
	RJMP _0x1A7
_0x1A0:
_0x1A9:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x1AB
	SBRS R17,3
	RJMP _0x1AC
	SUBI R19,-LOW(7)
	RJMP _0x1AD
_0x1AC:
	SUBI R19,-LOW(39)
_0x1AD:
_0x1AB:
	SBRC R17,4
	RJMP _0x1AF
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x1B1
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x1B0
_0x1B1:
	ORI  R17,LOW(16)
	RJMP _0x1B3
_0x1B0:
	CP   R20,R18
	BRLO _0x1B5
	SBRS R17,0
	RJMP _0x1B6
_0x1B5:
	RJMP _0x1B4
_0x1B6:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x1B7
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x1B3:
	SBRS R17,2
	RJMP _0x1B8
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x34
	CPI  R20,0
	BREQ _0x1B9
	SUBI R20,LOW(1)
_0x1B9:
_0x1B8:
_0x1B7:
_0x1AF:
	RCALL SUBOPT_0x2F
	CPI  R20,0
	BREQ _0x1BA
	SUBI R20,LOW(1)
_0x1BA:
_0x1B4:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x1AA
	RJMP _0x1A9
_0x1AA:
_0x1A7:
	SBRS R17,0
	RJMP _0x1BB
_0x1BC:
	CPI  R20,0
	BREQ _0x1BE
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x31
	RJMP _0x1BC
_0x1BE:
_0x1BB:
_0x1BF:
_0x181:
	LDI  R16,LOW(0)
_0x16C:
	RJMP _0x167
_0x169:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x35
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x35
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G2
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	RJMP _0x28A
_Lire_BP:

	.DSEG
_Etat_BP_S9:
	.BYTE 0x1

	.CSEG
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x36
	LDS  R30,_Etat_BP_S9
	CPI  R30,0
	BRNE _0x1D3
	CPI  R17,63
	BRNE _0x1D4
	MOV  R16,R17
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x36
	CP   R17,R16
	BRNE _0x1D5
	LDI  R30,LOW(1)
	STS  _Etat_BP_S9,R30
	LDI  R30,LOW(255)
	RJMP _0x28F
_0x1D5:
	CLR  R30
	RJMP _0x28F
	RJMP _0x1D7
_0x1D4:
	CLR  R30
	RJMP _0x28F
_0x1D7:
	RJMP _0x1D2
_0x1D3:
	CPI  R30,LOW(0x1)
	BRNE _0x1D2
	CPI  R17,63
	BREQ _0x1D9
	MOV  R16,R17
	RCALL SUBOPT_0x37
	ANDI R17,LOW(63)
	CP   R17,R16
	BRNE _0x1DA
	CLR  R30
	STS  _Etat_BP_S9,R30
	MOV  R30,R17
	RJMP _0x28F
_0x1DA:
	LDI  R30,LOW(255)
	RJMP _0x28F
	RJMP _0x1DC
_0x1D9:
	LDI  R30,LOW(255)
_0x1DC:
_0x1D2:
_0x28F:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x13
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1F
	RJMP _0x28A
_eeprom_page_read:
	SBIW R28,3
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   Y,R30
	LDD  R30,Y+6
	ANDI R31,HIGH(0x0)
	STD  Y+1,R30
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x3C
	CLR  R30
	STD  Y+2,R30
_0x1E0:
	LDD  R26,Y+2
	CPI  R26,LOW(0x1F)
	BRSH _0x1E1
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x3D
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	LD   R30,X+
	STD  Y+3,R26
	STD  Y+3+1,R27
	LDD  R30,Y+2
	SUBI R30,-LOW(1)
	STD  Y+2,R30
	RJMP _0x1E0
_0x1E1:
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3D
	RCALL _i2c_stop
	ADIW R28,8
	RET
_regle_HTR:
	SBIW R28,35
	RCALL __SAVELOCR6
	LDI  R21,LOW(0)
_0x1E3:
	RCALL SUBOPT_0x2A
	MOV  R30,R21
	CPI  R30,0
	BREQ PC+2
	RJMP _0x1E9
	RCALL SUBOPT_0x3E
	BRNE _0x1EA
	LDD  R26,Y+44
	CPI  R26,LOW(0x18)
	BRNE _0x1EB
	RCALL SUBOPT_0x3F
_0x1EB:
	LDD  R26,Y+44
	CPI  R26,LOW(0xFF)
	BRNE _0x1EC
	LDI  R30,LOW(23)
	STD  Y+44,R30
_0x1EC:
	RCALL SUBOPT_0x40
	BRNE _0x1EE
	RCALL SUBOPT_0x41
	BREQ _0x1ED
_0x1EE:
	RCALL SUBOPT_0x42
	__POINTW1FN _482,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x43
	__POINTW1FN _482,17
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x46
	LDI  R24,12
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
	LDD  R17,Y+44
_0x1ED:
	RJMP _0x1F0
_0x1EA:
	LDD  R26,Y+44
	CPI  R26,LOW(0x20)
	BRNE _0x1F1
	RCALL SUBOPT_0x3F
_0x1F1:
	LDD  R30,Y+44
	CPI  R30,0
	BRNE _0x1F2
	LDI  R30,LOW(31)
	STD  Y+44,R30
_0x1F2:
	RCALL SUBOPT_0x40
	BRNE _0x1F4
	RCALL SUBOPT_0x41
	BREQ _0x1F3
_0x1F4:
	RCALL SUBOPT_0x42
	__POINTW1FN _482,37
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x43
	__POINTW1FN _482,53
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x46
	LDI  R24,12
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
	LDD  R17,Y+44
_0x1F3:
_0x1F0:
	RCALL SUBOPT_0x2B
	BRNE _0x1F9
	LDD  R30,Y+44
	SUBI R30,-LOW(1)
	STD  Y+44,R30
	RJMP _0x1F8
_0x1F9:
	CPI  R30,LOW(0x2F)
	BRNE _0x1FA
	LDD  R30,Y+44
	SUBI R30,LOW(1)
	STD  Y+44,R30
	RJMP _0x1F8
_0x1FA:
	CPI  R30,LOW(0x37)
	BRNE _0x1FB
	LDI  R21,LOW(1)
	RJMP _0x1F8
_0x1FB:
	CPI  R30,LOW(0x3B)
	BRNE _0x1FD
	LDI  R21,LOW(3)
	RJMP _0x1F8
_0x1FD:
	LDI  R21,LOW(0)
_0x1F8:
	CLR  R30
	STD  Y+40,R30
	RJMP _0x1E8
_0x1E9:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x1FE
	RCALL SUBOPT_0x3E
	BRNE _0x1FF
	LDD  R26,Y+43
	CPI  R26,LOW(0x3C)
	BRNE _0x200
	CLR  R30
	STD  Y+43,R30
_0x200:
	LDD  R26,Y+43
	CPI  R26,LOW(0xFF)
	BRNE _0x201
	LDI  R30,LOW(59)
	STD  Y+43,R30
_0x201:
	RCALL SUBOPT_0x48
	BRNE _0x203
	RCALL SUBOPT_0x41
	BREQ _0x202
_0x203:
	RCALL SUBOPT_0x42
	__POINTW1FN _482,68
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x43
	__POINTW1FN _482,84
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x46
	LDI  R24,12
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
	LDD  R18,Y+43
_0x202:
	RJMP _0x205
_0x1FF:
	LDD  R26,Y+43
	CPI  R26,LOW(0xD)
	BRNE _0x206
	LDI  R30,LOW(1)
	STD  Y+43,R30
_0x206:
	LDD  R30,Y+43
	CPI  R30,0
	BRNE _0x207
	LDI  R30,LOW(12)
	STD  Y+43,R30
_0x207:
	RCALL SUBOPT_0x48
	BRNE _0x209
	RCALL SUBOPT_0x41
	BREQ _0x208
_0x209:
	RCALL SUBOPT_0x42
	__POINTW1FN _482,105
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x43
	__POINTW1FN _482,121
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x46
	LDI  R24,12
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
	LDD  R18,Y+43
_0x208:
_0x205:
	RCALL SUBOPT_0x2B
	BRNE _0x20E
	LDD  R30,Y+43
	SUBI R30,-LOW(1)
	STD  Y+43,R30
	RJMP _0x20D
_0x20E:
	CPI  R30,LOW(0x2F)
	BRNE _0x20F
	LDD  R30,Y+43
	SUBI R30,LOW(1)
	STD  Y+43,R30
	RJMP _0x20D
_0x20F:
	CPI  R30,LOW(0x37)
	BRNE _0x210
	LDI  R21,LOW(2)
	RJMP _0x20D
_0x210:
	CPI  R30,LOW(0x3B)
	BRNE _0x212
	LDI  R21,LOW(3)
	RJMP _0x20D
_0x212:
	LDI  R21,LOW(1)
_0x20D:
	LDI  R30,LOW(1)
	STD  Y+40,R30
	RJMP _0x1E8
_0x1FE:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0x213
	RCALL SUBOPT_0x3E
	BRNE _0x214
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0x3C)
	LDI  R30,HIGH(0x3C)
	CPC  R27,R30
	BRNE _0x215
	CLR  R30
	STD  Y+41,R30
	STD  Y+41+1,R30
_0x215:
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0xFFFF)
	LDI  R30,HIGH(0xFFFF)
	CPC  R27,R30
	BRNE _0x216
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	STD  Y+41,R30
	STD  Y+41+1,R31
_0x216:
	RCALL SUBOPT_0x49
	BRNE _0x218
	RCALL SUBOPT_0x41
	BREQ _0x217
_0x218:
	RCALL SUBOPT_0x42
	__POINTW1FN _482,136
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x43
	__POINTW1FN _482,152
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x46
	LDI  R24,12
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
	__GETWRS 19,20,41
_0x217:
	RJMP _0x21A
_0x214:
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0x834)
	LDI  R30,HIGH(0x834)
	CPC  R27,R30
	BRNE _0x21B
	RCALL SUBOPT_0x4A
_0x21B:
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0x7CF)
	LDI  R30,HIGH(0x7CF)
	CPC  R27,R30
	BRNE _0x21C
	RCALL SUBOPT_0x4A
_0x21C:
	RCALL SUBOPT_0x49
	BRNE _0x21E
	RCALL SUBOPT_0x41
	BREQ _0x21D
_0x21E:
	RCALL SUBOPT_0x42
	__POINTW1FN _482,172
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x43
	__POINTW1FN _482,188
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x46
	LDI  R24,12
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
	__GETWRS 19,20,41
_0x21D:
_0x21A:
	RCALL SUBOPT_0x2B
	BRNE _0x223
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	ADIW R30,1
	STD  Y+41,R30
	STD  Y+41+1,R31
	RJMP _0x222
_0x223:
	CPI  R30,LOW(0x2F)
	BRNE _0x224
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	SBIW R30,1
	STD  Y+41,R30
	STD  Y+41+1,R31
	RJMP _0x222
_0x224:
	CPI  R30,LOW(0x37)
	BRNE _0x225
	LDI  R21,LOW(0)
	RJMP _0x222
_0x225:
	CPI  R30,LOW(0x3B)
	BRNE _0x227
	LDI  R21,LOW(3)
	RJMP _0x222
_0x227:
	LDI  R21,LOW(2)
_0x222:
	LDI  R30,LOW(2)
	STD  Y+40,R30
	RJMP _0x1E8
_0x213:
	CPI  R30,LOW(0x3)
	BRNE _0x1E8
	LDD  R26,Y+45
	CPI  R26,LOW(0x1)
	BRNE _0x229
	RCALL SUBOPT_0x4B
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_set_date
	RJMP _0x22A
_0x229:
	RCALL SUBOPT_0x4B
	RCALL SUBOPT_0x2
	RCALL _rtc_set_time
_0x22A:
	CLR  R30
	CLR  R31
	RJMP _0x28E
_0x1E8:
	RJMP _0x1E3
_0x28E:
	RCALL __LOADLOCR6
	ADIW R28,47
	RET
_ext_int0_isr:
	RCALL __SAVEISR

	.DSEG
_g_data_SD:
	.BYTE 0x2

	.CSEG

	.DSEG
_g_data_aff_SD:
	.BYTE 0x1

	.CSEG

	.DSEG
_edge_SD:
	.BYTE 0x1

	.CSEG

	.DSEG
_bitcount_RX_SD:
	.BYTE 0x1

	.CSEG

	.DSEG
_bitcount_TX_SD:
	.BYTE 0x1

	.CSEG

	.DSEG
_is_up_SD:
	.BYTE 0x1

	.CSEG

	.DSEG
_shift_SD:
	.BYTE 0x1

	.CSEG
	ST   -Y,R16
	CLR  R30
	SBRC R2,2
	LDI  R30,1
	CPI  R30,0
	BREQ PC+2
	RJMP _0x230
	LDS  R30,_edge_SD
	CPI  R30,0
	BRNE _0x231
	LDS  R26,_bitcount_RX_SD
	CPI  R26,LOW(0xC)
	BRSH _0x233
	CLR  R30
	CP   R30,R26
	BRLO _0x234
_0x233:
	RJMP _0x232
_0x234:
	RCALL SUBOPT_0x4C
	STS  _g_data_SD,R30
	STS  _g_data_SD+1,R31
	SBIS 0x19,0
	RJMP _0x235
	LDS  R30,_g_data_SD
	LDS  R31,_g_data_SD+1
	ORI  R31,HIGH(0x8000)
	STS  _g_data_SD,R30
	STS  _g_data_SD+1,R31
_0x235:
_0x232:
	LDI  R30,LOW(3)
	OUT  0x35,R30
	LDI  R30,LOW(1)
	STS  _edge_SD,R30
	RJMP _0x236
_0x231:
	RCALL SUBOPT_0x3
	STS  _edge_SD,R30
	LDS  R30,_bitcount_RX_SD
	SUBI R30,LOW(1)
	STS  _bitcount_RX_SD,R30
	CPI  R30,0
	BREQ PC+2
	RJMP _0x237
	LDS  R26,_g_data_SD
	LDS  R27,_g_data_SD+1
	LDI  R30,LOW(5)
	RCALL __LSRW12
	STS  _g_data_SD,R30
	STS  _g_data_SD+1,R31
	RCALL SUBOPT_0x4C
	STS  _g_data_aff_SD,R30
	LDS  R30,_is_up_SD
	CPI  R30,0
	BREQ PC+2
	RJMP _0x238
	LDS  R30,_g_data_aff_SD
	CPI  R30,LOW(0xF0)
	BRNE _0x23C
	LDI  R30,LOW(1)
	STS  _is_up_SD,R30
	CLT
	BLD  R2,1
	RJMP _0x23B
_0x23C:
	CPI  R30,LOW(0x12)
	BRNE _0x23D
	RCALL SUBOPT_0x4D
	RJMP _0x23B
_0x23D:
	CPI  R30,LOW(0x59)
	BRNE _0x23F
	RCALL SUBOPT_0x4D
	RJMP _0x23B
_0x23F:
	LDS  R30,_shift_SD
	CPI  R30,0
	BRNE _0x240
	LDI  R16,LOW(0)
_0x242:
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x4F
	BREQ _0x244
	RCALL SUBOPT_0x4E
	CPI  R30,0
	BRNE _0x245
_0x244:
	RJMP _0x243
_0x245:
	SUBI R16,-1
	RJMP _0x242
_0x243:
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x4F
	BRNE _0x246
	LDI  R26,LOW(_unshifted*2)
	LDI  R27,HIGH(_unshifted*2)
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x51
	SBRC R2,1
	RJMP _0x247
	SET
	BLD  R2,1
_0x247:
_0x246:
	RJMP _0x248
_0x240:
	LDI  R16,LOW(0)
_0x24A:
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x53
	BREQ _0x24C
	RCALL SUBOPT_0x52
	LPM  R30,Z
	CPI  R30,0
	BRNE _0x24D
_0x24C:
	RJMP _0x24B
_0x24D:
	SUBI R16,-1
	RJMP _0x24A
_0x24B:
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x53
	BRNE _0x24E
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x51
	SBRC R2,1
	RJMP _0x24F
	SET
	BLD  R2,1
_0x24F:
_0x24E:
_0x248:
_0x23B:
	RJMP _0x250
_0x238:
	CLR  R30
	STS  _is_up_SD,R30
	LDS  R30,_g_data_aff_SD
	CPI  R30,LOW(0x12)
	BRNE _0x254
	RCALL SUBOPT_0x54
	RJMP _0x253
_0x254:
	CPI  R30,LOW(0x59)
	BRNE _0x253
	RCALL SUBOPT_0x54
_0x253:
_0x250:
	LDI  R30,LOW(11)
	STS  _bitcount_RX_SD,R30
_0x237:
_0x236:
	RJMP _0x22F
_0x230:
	CPI  R30,LOW(0x1)
	BRNE _0x22F
	LDS  R30,_bitcount_TX_SD
	CPI  R30,0
	BREQ _0x257
	__GETW1R 6,7
	RCALL __BSTB1
	IN   R30,0x19
	BLD  R30,0
	OUT  0x19,R30
	LDS  R30,_bitcount_TX_SD
	SUBI R30,LOW(1)
	STS  _bitcount_TX_SD,R30
	LSR  R7
	ROR  R6
	RJMP _0x258
_0x257:
	LDI  R30,LOW(10)
	STS  _bitcount_TX_SD,R30
	CLT
	BLD  R2,2
	CBI  0x1A,0
_0x258:
_0x22F:
	LD   R16,Y+
	RCALL __LOADISR
	RETI
_ds1621_get_status:
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x57
	RCALL _i2c_start
	SUBI R16,-LOW(1)
	RCALL SUBOPT_0x58
	RCALL SUBOPT_0x1
	RCALL _i2c_read
	MOV  R17,R30
	RCALL _i2c_stop
	MOV  R30,R17
	RCALL __LOADLOCR2
	RJMP _0x28B
_ds1621_set_status:
	RCALL _i2c_start
	RCALL SUBOPT_0x59
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x3B
	RCALL _i2c_stop
	RJMP _0x28C
_ds1621_set_temp:
	RCALL _i2c_start
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x1
	RCALL _i2c_write
	RCALL _i2c_stop
_0x25C:
	RCALL SUBOPT_0x2E
	RCALL _ds1621_get_status
	ANDI R30,LOW(0x10)
	BRNE _0x25C
	RJMP _0x28B
_ds1621_start:
	RCALL _i2c_start
	LD   R30,Y
	LSL  R30
	RCALL SUBOPT_0x5A
	LDI  R30,LOW(238)
	RCALL SUBOPT_0x39
	RCALL _i2c_stop
	RJMP _0x28D
_ds1621_init:
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x59
	SUBI R30,-LOW(8)
	ST   -Y,R30
	RCALL _ds1621_set_status
	RCALL SUBOPT_0x5B
	LDI  R30,LOW(162)
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5D
	LDI  R30,LOW(161)
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5D
	RCALL _ds1621_start
	RJMP _0x28A
_ds1621_temperature_10:
	SBIW R28,2
	ST   -Y,R16
	LDD  R30,Y+3
	LSL  R30
	ORI  R30,LOW(0x90)
	RCALL SUBOPT_0x56
	LDI  R30,LOW(170)
	RCALL SUBOPT_0x39
	RCALL _i2c_start
	SUBI R16,-LOW(1)
	RCALL SUBOPT_0x58
	RCALL SUBOPT_0x13
	RCALL _i2c_read
	STD  Y+2,R30
	RCALL SUBOPT_0x1
	RCALL _i2c_read
	STD  Y+1,R30
	RCALL _i2c_stop
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R30,LOW(7)
	RCALL __ASRW12
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RCALL __MULW12
	LDD  R16,Y+0
	RJMP _0x28A
_rtc_read:
	ST   -Y,R16
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x3A
	RCALL _i2c_start
	MOV  R30,R16
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0x1
	RCALL _i2c_read
	MOV  R16,R30
	RCALL _i2c_stop
	MOV  R30,R16
	LDD  R16,Y+0
	RJMP _0x28B
_rtc_write:
	RCALL _i2c_start
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x3B
	RCALL _i2c_stop
	RJMP _0x28B
_rtc_get_status:
	RCALL SUBOPT_0x60
	RCALL _rtc_read
	MOV  R4,R30
	BST  R4,1
	BLD  R2,0
	MOV  R30,R4
	RJMP _0x28D
_rtc_init:
	ST   -Y,R16
	LDI  R16,LOW(144)
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x26D
	LDI  R16,LOW(176)
_0x26D:
	CLR  R4
	CLT
	BLD  R2,0
	LDD  R30,Y+2
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x61
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x62
	RCALL _rtc_read
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x61
	LDI  R30,LOW(8)
	ST   -Y,R30
	ST   -Y,R16
	RCALL _rtc_write
	LDD  R16,Y+0
	RJMP _0x28B
_rtc_stop:
	RCALL SUBOPT_0x64
	ORI  R30,0x80
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	RJMP _0x28D
_rtc_start:
	RCALL SUBOPT_0x64
	ANDI R30,0x7F
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	RJMP _0x28D
_rtc_hold_off:
	RCALL SUBOPT_0x64
	ANDI R30,0xBF
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	RJMP _0x28D
_rtc_hold_on:
	RCALL SUBOPT_0x64
	ORI  R30,0x40
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
_0x28D:
	ADIW R28,1
	RET
_rtc_read_bcd:
	RCALL SUBOPT_0x67
	RCALL SUBOPT_0x67
	RCALL _rtc_read
	RCALL SUBOPT_0x68
_0x28C:
	ADIW R28,2
	RET
_rtc_write_bcd:
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x2E
	RCALL _bin2bcd
	RCALL SUBOPT_0x69
_0x28B:
	ADIW R28,3
	RET
_rtc_write_word:
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x2E
	RCALL _rtc_write
	RCALL SUBOPT_0x5B
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	ST   -Y,R30
	LDD  R30,Y+3
	ANDI R31,HIGH(0x0)
	RCALL SUBOPT_0x69
_0x28A:
	ADIW R28,4
	RET
_rtc_write_date:
	LDD  R30,Y+4
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x6A
	RCALL _bin2bcd
	PUSH R30
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	LSL  R30
	POP  R26
	OR   R30,R26
	RCALL SUBOPT_0x69
	RJMP _0x289
_rtc_get_time:
	RCALL SUBOPT_0x6B
	RCALL _rtc_hold_on
	LDD  R30,Y+8
	RCALL SUBOPT_0x29
	RCALL _rtc_read_bcd
	LD   R26,Y
	LDD  R27,Y+1
	RCALL SUBOPT_0x6C
	RCALL SUBOPT_0x6D
	RCALL _rtc_read_bcd
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL SUBOPT_0x6C
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL SUBOPT_0x6C
	RCALL SUBOPT_0x62
	RCALL _rtc_read_bcd
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL SUBOPT_0x6C
	RCALL _rtc_hold_off
	ADIW R28,9
	RET
_rtc_set_time:
	RCALL SUBOPT_0x6A
	RCALL _rtc_stop
	LDD  R30,Y+4
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x6E
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x6E
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x6E
	RCALL _rtc_start
	RJMP _0x289
_rtc_get_date:
	SBIW R28,3
	RCALL SUBOPT_0x70
	RCALL _rtc_hold_on
	RCALL SUBOPT_0x70
	RCALL SUBOPT_0x71
	RCALL _rtc_read
	RCALL SUBOPT_0x72
	RCALL SUBOPT_0x16
	RCALL _rtc_read
	ANDI R30,LOW(0x1F)
	RCALL SUBOPT_0x68
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ST   X,R30
	RCALL SUBOPT_0x70
	RCALL _rtc_hold_off
	LDD  R30,Y+2
	RCALL SUBOPT_0x63
	RCALL _bcd2bin
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	ST   X,R30
	LDD  R30,Y+2
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	LSR  R30
	RCALL SUBOPT_0x72
	RCALL SUBOPT_0x4
	RCALL _rtc_read
	PUSH R30
	RCALL SUBOPT_0x70
	LDI  R30,LOW(17)
	ST   -Y,R30
	RCALL _rtc_read
	MOV  R31,R30
	CLR  R30
	POP  R26
	CLR  R27
	OR   R30,R26
	OR   R31,R27
	ST   Y,R30
	STD  Y+1,R31
	LD   R30,Y
	ANDI R30,LOW(0x3)
	MOV  R26,R30
	LDD  R30,Y+2
	CP   R30,R26
	BREQ _0x279
	RCALL SUBOPT_0x70
	RCALL SUBOPT_0x4
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RCALL SUBOPT_0x73
_0x279:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL __PUTWP1
	ADIW R28,10
	RET
_rtc_set_date:
	RCALL SUBOPT_0x6A
	RCALL SUBOPT_0x4
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0x6A
	RCALL _rtc_stop
	RCALL SUBOPT_0x6A
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x6F
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_write_date
	RCALL SUBOPT_0x6A
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x6A
	RCALL SUBOPT_0x6E
	RCALL _rtc_start
_0x289:
	ADIW R28,5
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G9:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_write_byte:
	RCALL __lcd_ready
	RCALL SUBOPT_0x67
	RCALL SUBOPT_0x74
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	RCALL SUBOPT_0x75
	ADIW R28,2
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G9:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G9)
	SBCI R31,HIGH(-__base_y_G9)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x75
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	RCALL SUBOPT_0x6D
	RCALL SUBOPT_0x74
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL SUBOPT_0x74
	RCALL SUBOPT_0x13
	RCALL __lcd_write_data
	CLR  R30
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0x282
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0x1
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x282:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G9:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G9:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G9,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G9,3
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x76
	RCALL __long_delay_G9
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G9
	RCALL __long_delay_G9
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x75
	RCALL __long_delay_G9
	RCALL SUBOPT_0x62
	RCALL __lcd_write_data
	RCALL __long_delay_G9
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x75
	RCALL __long_delay_G9
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G9
	CPI  R30,LOW(0x5)
	BREQ _0x287
	CLR  R30
	RJMP _0x288
_0x287:
	RCALL __lcd_ready
	RCALL SUBOPT_0x16
	RCALL __lcd_write_data
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x288:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	CLR  R30
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 33 TIMES
SUBOPT_0x1:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x2:
	ST   -Y,R30
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(2)
	OUT  0x35,R30
	CLR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(16)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	MOV  R30,R16
	CLR  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R30
	RJMP _lcd_write_byte

;OPTIMIZER ADDED SUBROUTINE, CALLED 57 TIMES
SUBOPT_0x7:
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 49 TIMES
SUBOPT_0x8:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 51 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	RCALL _Lire_BP
	MOV  R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0xC:
	LDS  R30,_etat
	LDS  R26,_etat_1
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	LDI  R30,LOW(_menu_BP*2)
	LDI  R31,HIGH(_menu_BP*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(_menu*2)
	LDI  R31,HIGH(_menu*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0xF:
	RCALL _Affiche_LCD
	RJMP _Affiche_fleches

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x10:
	MOV  R30,R18
	CPI  R30,LOW(0x1F)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	RCALL _Led_BP_TOR
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LDI  R30,LOW(_menu_TOR*2)
	LDI  R31,HIGH(_menu_TOR*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x13:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	LDI  R30,LOW(_menu_Analog*2)
	LDI  R31,HIGH(_menu_Analog*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x15:
	LDI  R30,LOW(_menu_ECHAP*2)
	LDI  R31,HIGH(_menu_ECHAP*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x16:
	LDI  R30,LOW(6)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x17:
	RCALL __MULW12U
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x18:
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	RCALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __DIVW21U
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	RCALL __MULW12U
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x1C:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1D:
	RCALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_time
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1F:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES
SUBOPT_0x20:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x21:
	RCALL _sprintf
	ADIW R28,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R8
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	MOV  R30,R9
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x24:
	MOV  R30,R10
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	ST   -Y,R13
	ST   -Y,R14
	LDS  R30,_mn_mois
	ST   -Y,R30
	LDS  R30,_sec_annee
	LDS  R31,_sec_annee+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _regle_HTR
	LDI  R30,LOW(5)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x27:
	RCALL _Affiche_LCD
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	RCALL _lcd_gotoxy
	LDI  R30,LOW(15)
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x29:
	ST   -Y,R30
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	RCALL _Lire_BP
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2B:
	MOV  R30,R16
	CPI  R30,LOW(0x1F)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x2C:
	LDI  R30,LOW(1)
	MOV  R18,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x2E:
	LDD  R30,Y+2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2F:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x30:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x33:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x34:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x35:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x36:
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x37:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x38:
	RCALL _i2c_start
	LDD  R30,Y+7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES
SUBOPT_0x39:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x3A:
	LDD  R30,Y+1
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x3B:
	LD   R30,Y
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3C:
	ORI  R30,1
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3D:
	RCALL _i2c_read
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3E:
	LDD  R30,Y+45
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3F:
	CLR  R30
	STD  Y+44,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x40:
	LDD  R30,Y+44
	CP   R30,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x41:
	LDD  R26,Y+40
	CP   R21,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x42:
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x43:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x44:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+48
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x45:
	LDD  R30,Y+51
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x46:
	LDD  R30,Y+53
	LDD  R31,Y+53+1
	RCALL __CWD1
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x47:
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x48:
	LDD  R30,Y+43
	CP   R30,R18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x49:
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	CP   R30,R19
	CPC  R31,R20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4A:
	MOVW R26,R28
	ADIW R26,43
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4B:
	LDD  R30,Y+46
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	LDD  R30,Y+44
	LDD  R31,Y+44+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4C:
	LDS  R30,_g_data_SD
	LDS  R31,_g_data_SD+1
	LSR  R31
	ROR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4D:
	LDI  R30,LOW(1)
	STS  _shift_SD,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4E:
	LDI  R26,LOW(_unshifted*2)
	LDI  R27,HIGH(_unshifted*2)
	MOV  R30,R16
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4F:
	LDS  R26,_g_data_aff_SD
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x50:
	MOV  R30,R16
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x51:
	ADIW R30,1
	LPM  R5,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x52:
	LDI  R26,LOW(_shifted*2)
	LDI  R27,HIGH(_shifted*2)
	RJMP SUBOPT_0x50

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x53:
	LPM  R30,Z
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x54:
	CLR  R30
	STS  _shift_SD,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x55:
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0x90)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x56:
	MOV  R16,R30
	RCALL _i2c_start
	ST   -Y,R16
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x57:
	LDI  R30,LOW(172)
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x58:
	ST   -Y,R16
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x59:
	LDD  R30,Y+1
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5A:
	ORI  R30,LOW(0x90)
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x5B:
	LDD  R30,Y+3
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x5C:
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5D:
	RCALL _ds1621_set_temp
	RJMP SUBOPT_0x5B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5E:
	ST   -Y,R30
	RJMP SUBOPT_0x5B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5F:
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0xA0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x60:
	LD   R30,Y
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x61:
	RCALL _rtc_write
	RJMP SUBOPT_0x2E

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x62:
	LDI  R30,LOW(4)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x63:
	ANDI R30,LOW(0x3F)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x64:
	LD   R30,Y
	ST   -Y,R30
	RCALL _rtc_get_status
	MOV  R30,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x65:
	MOV  R4,R30
	RJMP SUBOPT_0x60

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x66:
	ST   -Y,R4
	RJMP _rtc_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x67:
	LDD  R30,Y+1
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x68:
	ST   -Y,R30
	RJMP _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x69:
	ST   -Y,R30
	RJMP _rtc_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x6A:
	LDD  R30,Y+4
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x6B:
	LDD  R30,Y+8
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x6C:
	ST   X,R30
	RJMP SUBOPT_0x6B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6D:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x6E:
	RCALL _rtc_write_bcd
	RJMP SUBOPT_0x6A

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6F:
	LDD  R30,Y+5
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x70:
	LDD  R30,Y+9
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x71:
	LDI  R30,LOW(5)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x72:
	STD  Y+2,R30
	RJMP SUBOPT_0x70

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x73:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _rtc_write_word

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x74:
	RCALL __lcd_write_data
	RJMP __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x75:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x76:
	RCALL __long_delay_G9
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G9

_abs:
	ld   r30,y+
	ld   r31,y+
	sbiw r30,0
	brpl __abs0
	com  r30
	com  r31
	adiw r30,1
__abs0:
	ret

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_puts:
	ld   r30,y+
	ld   r31,y+
__puts0:
	ld   r22,z+
	tst  r22
	breq __puts1
	push r30
	push r31
	rcall __puts2
	pop  r31
	pop  r30
	rjmp __puts0
__puts1:
	ldi  r22,10
__puts2:
	st   -y,r22
	rjmp _putchar

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_bcd2bin:
	ld   r30,y
	swap r30
	andi r30,0xf
	mov  r26,r30
	lsl  r26
	lsl  r26
	add  r30,r26
	lsl  r30
	ld   r26,y+
	andi r26,0xf
	add  r30,r26
	ret

_bin2bcd:
	ld   r26,y+
	clr  r30
__bin2bcd0:
	subi r26,10
	brmi __bin2bcd1
	subi r30,-16
	rjmp __bin2bcd0
__bin2bcd1:
	subi r26,-10
	add  r30,r26
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__BSTB1:
	CLT
	CLR  R0
	CPSE R30,R0
	SET
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

