
;CodeVisionAVR C Compiler V2.04.8a Standard
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 160 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x025F
	.EQU __DSTACK_SIZE=0x00A0
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _heures=R5
	.DEF _minutes=R4
	.DEF _secondes=R7
	.DEF _secondes_1=R6
	.DEF _dizieme=R9
	.DEF _Heure_ou_Date=R8
	.DEF _H_J=R11
	.DEF _mn_mois=R10
	.DEF _sec_annee=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_menu:
	.DB  0x20,0x20,0x5B,0x45,0x4E,0x54,0x52,0x5D
	.DB  0x3E,0x4F,0x75,0x69,0x20,0x20,0x20,0x20
	.DB  0x0
_menu_BP:
	.DB  0x54,0x65,0x73,0x74,0x3F,0x20,0x42,0x50
	.DB  0x2D,0x3E,0x44,0x45,0x4C,0x20,0x20,0x20
	.DB  0x0
_menu_TOR:
	.DB  0x54,0x65,0x73,0x74,0x3F,0x20,0x54,0x4F
	.DB  0x52,0x2D,0x3E,0x44,0x45,0x4C,0x20,0x20
	.DB  0x0
_menu_Analog:
	.DB  0x54,0x65,0x73,0x74,0x3F,0x20,0x45,0x5F
	.DB  0x41,0x6E,0x61,0x6C,0x6F,0x67,0x20,0x20
	.DB  0x0
_menu_Buzzer:
	.DB  0x54,0x65,0x73,0x74,0x3F,0x20,0x42,0x75
	.DB  0x7A,0x7A,0x65,0x72,0x20,0x20,0x20,0x20
	.DB  0x0
_menu_EEPROM:
	.DB  0x54,0x65,0x73,0x74,0x3F,0x20,0x45,0x45
	.DB  0x50,0x52,0x4F,0x4D,0x20,0x20,0x20,0x20
	.DB  0x0
_menu_RS232:
	.DB  0x54,0x65,0x73,0x74,0x3F,0x20,0x52,0x53
	.DB  0x32,0x33,0x32,0x54,0x78,0x20,0x20,0x20
	.DB  0x0
_menu_PWM:
	.DB  0x54,0x65,0x73,0x74,0x3F,0x20,0x50,0x57
	.DB  0x4D,0x41,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0
_menu_PC:
	.DB  0x54,0x73,0x74,0x3F,0x20,0x43,0x6C,0x61
	.DB  0x76,0x31,0x30,0x32,0x20,0x50,0x43,0x20
	.DB  0x0
_menu_ECHAP:
	.DB  0x5B,0x45,0x43,0x48,0x41,0x50,0x5D,0x3E
	.DB  0x51,0x75,0x69,0x74,0x74,0x65,0x72,0x20
	.DB  0x0
_flecheHaut:
	.DB  0x4,0xE,0x15,0x4,0x4,0x4,0x4,0x0
_flecheBas:
	.DB  0x4,0x4,0x4,0x4,0x15,0xE,0x4,0x0
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0
_unshifted:
	.DB  0xD,0x9,0xE,0x7C,0x15,0x61,0x16,0x26
	.DB  0x1A,0x77,0x1B,0x73,0x1C,0x71,0x1D,0x7A
	.DB  0x1E,0x0,0x21,0x63,0x22,0x78,0x23,0x64
	.DB  0x24,0x65,0x25,0x27,0x26,0x22,0x29,0x20
	.DB  0x2A,0x76,0x2B,0x66,0x2C,0x74,0x2D,0x72
	.DB  0x2E,0x28,0x31,0x6E,0x32,0x62,0x33,0x68
	.DB  0x34,0x67,0x35,0x79,0x36,0x2D,0x39,0x2C
	.DB  0x3A,0x2C,0x3B,0x6A,0x3C,0x75,0x3D,0x0
	.DB  0x3E,0x5F,0x41,0x3B,0x42,0x6B,0x43,0x69
	.DB  0x44,0x29,0x45,0x30,0x46,0x5E,0x49,0x3A
	.DB  0x4A,0x2D,0x4B,0x6C,0x4C,0x0,0x4D,0x70
	.DB  0x4E,0x29,0x52,0x0,0x54,0x0,0x55,0x0
	.DB  0x5A,0x0,0x5B,0x22,0x5D,0x0,0x61,0x3C
	.DB  0x66,0x0,0x69,0x31,0x6B,0x34,0x6C,0x37
	.DB  0x70,0x30,0x71,0x2C,0x72,0x32,0x73,0x35
	.DB  0x74,0x36,0x75,0x38,0x79,0x2B,0x7A,0x33
	.DB  0x7B,0x21,0x7C,0x2A,0x7D,0x39,0x0,0x0
_shifted:
	.DB  0xD,0x0,0xE,0x0,0x15,0x41,0x16,0x31
	.DB  0x1A,0x57,0x1B,0x53,0x1C,0x51,0x1D,0x5A
	.DB  0x1E,0x32,0x21,0x43,0x22,0x58,0x23,0x44
	.DB  0x24,0x45,0x25,0x34,0x26,0x33,0x29,0x20
	.DB  0x2A,0x56,0x2B,0x46,0x2C,0x54,0x2D,0x52
	.DB  0x2E,0x35,0x31,0x4E,0x32,0x42,0x33,0x48
	.DB  0x34,0x47,0x35,0x59,0x36,0x36,0x39,0x4C
	.DB  0x3A,0x3F,0x3B,0x4A,0x3C,0x55,0x3D,0x37
	.DB  0x3E,0x38,0x41,0x2E,0x42,0x4B,0x43,0x49
	.DB  0x44,0x4F,0x45,0x30,0x46,0x39,0x49,0x2F
	.DB  0x4A,0x0,0x4B,0x4C,0x4C,0x0,0x4D,0x50
	.DB  0x4E,0xB0,0x52,0x0,0x54,0x0,0x55,0x2B
	.DB  0x5A,0x0,0x5B,0x5E,0x5D,0x2A,0x61,0x3E
	.DB  0x66,0x0,0x69,0x31,0x6B,0x34,0x6C,0x37
	.DB  0x70,0x30,0x71,0x2C,0x72,0x32,0x73,0x35
	.DB  0x74,0x36,0x75,0x38,0x79,0x2B,0x7A,0x33
	.DB  0x7B,0xA7,0x7C,0x2A,0x7D,0x39,0x0,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x6:
	.DB  0x1
_0x7:
	.DB  0x1
_0x9:
	.DB  0x0,0x19,0x33,0x4C,0x66,0x7F,0x99,0xB2
	.DB  0xCC,0xE5,0xFF,0x0,LOW(_0x8),HIGH(_0x8)
_0xD7:
	.DB  0x0,0x0,0x1,0x0,0x0,0x0
_0x0:
	.DB  0x0,0x20,0x54,0x65,0x73,0x74,0x20,0x63
	.DB  0x61,0x72,0x74,0x65,0x20,0x53,0x53,0x49
	.DB  0x20,0x0,0x20,0x20,0x20,0x32,0x33,0x2F
	.DB  0x30,0x33,0x2F,0x32,0x30,0x31,0x31,0x20
	.DB  0x20,0x20,0x0,0x20,0x20,0x44,0x44,0x50
	.DB  0x20,0x3D,0x20,0x25,0x2D,0x75,0x2E,0x25
	.DB  0x2D,0x75,0x25,0x2D,0x75,0x56,0x0,0x43
	.DB  0x61,0x70,0x74,0x65,0x75,0x72,0x20,0x44
	.DB  0x53,0x31,0x36,0x32,0x31,0x20,0x20,0x0
	.DB  0x54,0x65,0x6D,0x70,0x2E,0x20,0x3D,0x20
	.DB  0x25,0x2D,0x69,0x2E,0x25,0x2D,0x75,0x25
	.DB  0x2D,0x63,0x43,0x0,0x20,0x25,0x2D,0x75
	.DB  0x20,0x2F,0x20,0x25,0x2D,0x75,0x20,0x2F
	.DB  0x20,0x25,0x2D,0x69,0x0,0x25,0x2D,0x75
	.DB  0x68,0x20,0x2F,0x20,0x25,0x2D,0x75,0x6D
	.DB  0x6E,0x20,0x2F,0x20,0x25,0x2D,0x75,0x73
	.DB  0x20,0x0,0x20,0x20,0x52,0x65,0x67,0x6C
	.DB  0x61,0x67,0x65,0x20,0x48,0x54,0x52,0x0
	.DB  0x53,0x45,0x54,0x3E,0x48,0x20,0x45,0x54
	.DB  0x52,0x3E,0x44,0x61,0x74,0x65,0x20,0x0
	.DB  0x25,0x75,0x2F,0x25,0x75,0x2F,0x25,0x75
	.DB  0x0,0x52,0x61,0x70,0x2E,0x20,0x63,0x79
	.DB  0x63,0x6C,0x20,0x3D,0x20,0x25,0x2D,0x75
	.DB  0x25,0x25,0x0,0x49,0x4E,0x43,0x3E,0x2B
	.DB  0x20,0x44,0x45,0x43,0x3E,0x2D,0x20,0x45
	.DB  0x53,0x63,0x3E,0x0,0x43,0x61,0x76,0x61
	.DB  0x6C,0x20,0x50,0x41,0x4F,0x20,0x31,0x2D
	.DB  0x32,0x20,0x4F,0x4B,0x0,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0x53,0x6F
	.DB  0x72,0x74,0x69,0x72,0x20,0x3D,0x20,0x32
	.DB  0x78,0x45,0x43,0x48,0x41,0x50,0x0,0x53
	.DB  0x6F,0x72,0x74,0x69,0x72,0x20,0x3D,0x20
	.DB  0x32,0x78,0x50,0x41,0x32,0x20,0x20,0x0
	.DB  0x20,0x20,0x20,0x50,0x41,0x35,0x20,0x2D
	.DB  0x3E,0x20,0x41,0x4C,0x4C,0x20,0x20,0x20
	.DB  0x0,0x20,0x20,0x20,0x50,0x41,0x34,0x20
	.DB  0x2D,0x3E,0x20,0x50,0x42,0x34,0x20,0x20
	.DB  0x20,0x0,0x20,0x20,0x20,0x50,0x41,0x33
	.DB  0x20,0x2D,0x3E,0x20,0x50,0x42,0x33,0x20
	.DB  0x20,0x20,0x0,0x20,0x20,0x20,0x50,0x41
	.DB  0x31,0x20,0x2D,0x3E,0x20,0x50,0x42,0x31
	.DB  0x20,0x20,0x20,0x0,0x20,0x20,0x20,0x50
	.DB  0x41,0x32,0x20,0x2D,0x3E,0x20,0x50,0x42
	.DB  0x32,0x20,0x20,0x20,0x0,0x20,0x20,0x20
	.DB  0x50,0x41,0x30,0x20,0x2D,0x3E,0x20,0x50
	.DB  0x42,0x30,0x20,0x20,0x20,0x0,0x20,0x54
	.DB  0x65,0x73,0x74,0x20,0x42,0x50,0x78,0x2D
	.DB  0x3E,0x44,0x45,0x4C,0x78,0x0,0x54,0x65
	.DB  0x73,0x74,0x20,0x54,0x4F,0x52,0x78,0x2D
	.DB  0x3E,0x44,0x45,0x4C,0x78,0x0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x2060003:
	.DB  0xB
_0x2060004:
	.DB  0xA
_0x2080003:
	.DB  0x1
_0x2080000:
	.DB  0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D,0x20
	.DB  0x4F,0x3E,0x6D,0x6E,0x20,0x45,0x3E,0x53
	.DB  0x0,0x68,0x3A,0x20,0x25,0x2D,0x75,0x68
	.DB  0x2F,0x25,0x2D,0x75,0x6D,0x6E,0x2F,0x25
	.DB  0x2D,0x75,0x73,0x20,0x0,0x49,0x3E,0x2B
	.DB  0x20,0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x4D
	.DB  0x20,0x45,0x3E,0x53,0x0,0x4A,0x3A,0x20
	.DB  0x25,0x2D,0x75,0x2F,0x25,0x2D,0x75,0x2F
	.DB  0x25,0x2D,0x69,0x0,0x49,0x3E,0x2B,0x20
	.DB  0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x73,0x20
	.DB  0x45,0x3E,0x53,0x0,0x6D,0x6E,0x3A,0x20
	.DB  0x25,0x2D,0x75,0x68,0x2F,0x25,0x2D,0x75
	.DB  0x6D,0x6E,0x2F,0x25,0x2D,0x75,0x73,0x20
	.DB  0x0,0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D
	.DB  0x20,0x4F,0x3E,0x41,0x20,0x45,0x3E,0x53
	.DB  0x0,0x4D,0x3A,0x20,0x25,0x2D,0x75,0x2F
	.DB  0x25,0x2D,0x75,0x2F,0x25,0x2D,0x69,0x0
	.DB  0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D,0x20
	.DB  0x4F,0x3E,0x68,0x20,0x45,0x3E,0x53,0x0
	.DB  0x73,0x3A,0x20,0x25,0x2D,0x75,0x68,0x2F
	.DB  0x25,0x2D,0x75,0x6D,0x6E,0x2F,0x25,0x2D
	.DB  0x75,0x73,0x20,0x0,0x49,0x3E,0x2B,0x20
	.DB  0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x4A,0x20
	.DB  0x45,0x3E,0x53,0x0,0x41,0x3A,0x20,0x25
	.DB  0x2D,0x75,0x2F,0x25,0x2D,0x75,0x2F,0x25
	.DB  0x2D,0x69,0x0,0x69,0x6E,0x63,0x2F,0x64
	.DB  0x65,0x63,0x3D,0x2B,0x2F,0x2D,0x20,0x2D
	.DB  0x3E,0x4F,0x6B,0x0,0x25,0x2D,0x75,0x25
	.DB  0x2D,0x75,0x2E,0x25,0x2D,0x75,0x20,0x6D
	.DB  0x6C,0x2F,0x68,0x20,0x2D,0x3E,0x45,0x4E
	.DB  0x54,0x52,0x0,0x31,0x2F,0x33,0x20,0x54
	.DB  0x45,0x52,0x55,0x4D,0x4F,0x20,0x35,0x30
	.DB  0x43,0x43,0x0,0x32,0x2F,0x33,0x20,0x4D
	.DB  0x4F,0x4E,0x2F,0x42,0x44,0x20,0x35,0x30
	.DB  0x43,0x43,0x0,0x33,0x2F,0x33,0x20,0x20
	.DB  0x20,0x20,0x20,0x42,0x44,0x20,0x32,0x30
	.DB  0x43,0x43,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x3F,0x3F,0x3F,0x3F,0x3F,0x3F
	.DB  0x3F,0x3F,0x0,0x25,0x2D,0x75,0x25,0x2D
	.DB  0x75,0x2E,0x25,0x2D,0x75,0x20,0x6D,0x6D
	.DB  0x2F,0x73,0x20,0x2D,0x3E,0x45,0x4E,0x54
	.DB  0x52,0x0,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x52,0x65,0x6E,0x74,0x72
	.DB  0x65,0x72,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x53,0x6F,0x72
	.DB  0x74,0x69,0x72,0x0
_0x20E0003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _g_key_ASCII
	.DW  _0x6*2

	.DW  0x01
	.DW  _etat_1
	.DW  _0x7*2

	.DW  0x01
	.DW  _0x8
	.DW  _0x0*2

	.DW  0x06
	.DW  0x04
	.DW  _0xD7*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

	.DW  0x01
	.DW  _bitcount_RX_S1030000000
	.DW  _0x2060003*2

	.DW  0x01
	.DW  _bitcount_TX_S1030000000
	.DW  _0x2060004*2

	.DW  0x01
	.DW  _Etat_BP_S1040000000
	.DW  _0x2080003*2

	.DW  0x02
	.DW  __base_y_G107
	.DW  _0x20E0003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x100

	.CSEG
;/*************************************************************
;Project :  Test des fonctionnalits de la carte ATMEGA8535 SSI
;Create :  8/03/2003 pour AT90S8535
;Version : 1
;Rvision : 7     Date    : 23/03/2011
;Author  : Philippe Mariano
;Company : LYCEE Pierre Emile MARTIN
;Comments: Test des BP, des LED, des entres TOR, du Buzzer,
;de l'entre analogique, du capteur de temprature DS1621,
;de l'EEPROM externe, de l'HTR PCF8583, de la liaison RS232,
;de la sortie PWMA, d'un clavier 102 touches (type IBM)
;
;Chip type           : ATMEGA8535
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Internal SRAM size  : 512
;External SRAM size  : 0
;Data Stack size     : > 153 !!!!!!!!!!!!!!!!!
;************************************************************/
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;//=====================================================================================================================
;// Bibliothques non gnres par Wizard ( rajouter manuellement)
;//---------------------------------------------------------------------------------------------------------------------
;#include <delay.h>          // contient la fonction delay_ms
;#include <stdio.h>          // contient la fonction sprintf
;#include <stdlib.h>         // contient la fonction itoa
;#include <math.h>
;//---------------------------------------------------------------------------------------------------------------------
;// Ces fichiers d'en-tte et les bibliothques associes doivent tre placs dans le rpertoire du projet
;//---------------------------------------------------------------------------------------------------------------------
;#include "LitClav102.h"     // Sous-programme de dsrialisation et de dcodage de la
;			                // trame issue du clavier de PC (102T)
;#include "ssi2.h" 	        // Sous-programme Affiche_LCD, Lire_BP
;//=====================================================================================================================
;
;//=====================================================================================================================
;// Dfinitions
;//---------------------------------------------------------------------------------------------------------------------
;// Boolens
;//---------------------------------------------------------------------------------------------------------------------
;#define VRAI                1
;#define FAUX                0
;//---------------------------------------------------------------------------------------------------------------------
;// Accs aux caractres en CGRAM
;//---------------------------------------------------------------------------------------------------------------------
;#define Caractere_FlecheH	0
;#define Caractere_FlecheB	1
;//---------------------------------------------------------------------------------------------------------------------
;// @ I2C HTR
;//---------------------------------------------------------------------------------------------------------------------
;#define	adresse_HTR     	0
;//---------------------------------------------------------------------------------------------------------------------
;// Adresse CGRAM de l'afficheur LCD
;//---------------------------------------------------------------------------------------------------------------------
;#define Add_FlecheH_CGRAM   0x40 // @1 Caractre flche haut
;#define Add_FlecheB_CGRAM   0x48 // @2 Caractre flche bas
;//=====================================================================================================================
;
;//=====================================================================================================================
;// I2C Bus functions
;//---------------------------------------------------------------------------------------------------------------------
;#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
; 0000 0044 #endasm
;#include <i2c.h>
;//---------------------------------------------------------------------------------------------------------------------
;// DS1621 Thermometer/Thermostat functions
;#include <ds1621.h>
;//---------------------------------------------------------------------------------------------------------------------
;// PCF8583 Real Time Clock functions
;#include <pcf8583.h>
;//---------------------------------------------------------------------------------------------------------------------
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x15
; 0000 0050 #endasm
;#include <lcd.h>
;//---------------------------------------------------------------------------------------------------------------------
;#define ADC_VREF_TYPE 0x00
;//---------------------------------------------------------------------------------------------------------------------
;// Read the AD conversion result
;unsigned int read_adc(unsigned char adc_input)
; 0000 0057 {

	.CSEG
_read_adc:
; 0000 0058 ADMUX=adc_input|ADC_VREF_TYPE;
;	adc_input -> Y+0
	LD   R30,Y
	OUT  0x7,R30
; 0000 0059 // Start the AD conversion
; 0000 005A ADCSRA|=0x40;
	SBI  0x6,6
; 0000 005B // Wait for the AD conversion to complete
; 0000 005C while ((ADCSRA & 0x10)==0);
_0x3:
	SBIS 0x6,4
	RJMP _0x3
; 0000 005D ADCSRA|=0x10;
	SBI  0x6,4
; 0000 005E return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
; 0000 005F }
;//=====================================================================================================================
;
;//=====================================================================================================================
;// Declare your global variables here
;//---------------------------------------------------------------------------------------------------------------------
;// type 		    nom 				       		dsignation
;//---------------------------------------------------------------------------------------------------------------------
;/* Communication avec le clavier PS2
;//---------------------------------------------------------------------------------------------------------------------
;Le programme principal se synchronise avec la routine d'interruption ext_int0_isr(void) situe dans la bibliothque
;"LitClav.lib" grce aux variables ci-dessous (voir le fichier d'en-tte litClav102.h)
;---------------------------------------------------------------------------------------------------------------------*/
;unsigned char g_key_ASCII=0x01; 	        // Contient le code ASCII de la touche presse ( initialiser avec un caractre

	.DSEG
;                                        // n'existant pas sur le clavier utilis)
;
;bit g_flag_char = FAUX;			        // g_flag_char = 1 lorsqu'une touche est appuye
;					                    // g_flag_char = 0 lorsqu'une touche a t relche
;
;bit g_Sens_transfert = RECEPTION;		        // Indique le sens de la communication
;					                    // g_Sens_transfert = 0 => C <--- clavier
;			  		                    // g_Sens_transfert = 1 => C ---> clavier
;unsigned int g_Trame_TX;                // Contient la valeur  envoyer au clavier
;//---------------------------------------------------------------------------------------------------------------------
;char display_buffer_ligne0[17]; 			            // tampon ligne 0 de l'afficheur
;char display_buffer_ligne1[17]; 	       		        // tampon ligne 1 de l'afficheur
;//---------------------------------------------------------------------------------------------------------------------
;unsigned char heures = 0, minutes = 0, secondes = 0, secondes_1 = 1, dizieme = 0; 	//stockage de l'heure
;unsigned char Heure_ou_Date, H_J, mn_mois;
;unsigned int sec_annee;
;//---------------------------------------------------------------------------------------------------------------------
;// Etats du graphe des menus
;enum Etat_Test {LedBP,LedTOR, Analog,Temperature, Reglage_HTR,Horloge, Buzzer, EEPROM,RS232Tx, MOT_PWM,REG_PWM,
;CLAV_PC,REG_TST_CLAV102,TST_CLAV_102T } etat=LedBP, etat_1=LedTOR;
;//=====================================================================================================================
;// Constantes en flash
;//---------------------------------------------------------------------------------------------------------------------
;flash char menu[]	 = "  [ENTR]>Oui    ";
;flash char menu_BP[]     = "Test? BP->DEL   ";
;flash char menu_TOR[] 	 = "Test? TOR->DEL  ";
;flash char menu_Analog[] = "Test? E_Analog  ";
;flash char menu_Buzzer[] = "Test? Buzzer    ";
;flash char menu_EEPROM[] = "Test? EEPROM    ";
;flash char menu_RS232[]  = "Test? RS232Tx   ";
;flash char menu_PWM[]    = "Test? PWMA      ";
;flash char menu_PC[]     = "Tst? Clav102 PC ";
;flash char menu_ECHAP[]  = "[ECHAP]>Quitter ";
;//---------------------------------------------------------------------------------------------------------------------
;// Caractres personnaliss placs dans la mmoire CGRAM du LCD
;const unsigned char flecheHaut[8] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    // @1 CGRAM
;const unsigned char flecheBas[8] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     // @2 CGRAM
;//---------------------------------------------------------------------------------------------------------------------
;// Prototypes des fonctions
;//---------------------------------------------------------------------------------------------------------------------
;int Led_BP_TOR(char entree);  // test des Leds et des BPs
;void Affiche_fleches(void);
;//=====================================================================================================================
;
;//=====================================================================================================================
;//=====================================================================================================================
;// Programme principal
;//---------------------------------------------------------------------------------------------------------------------
;void main(void)
; 0000 009E {

	.CSEG
_main:
; 0000 009F //---------------------------------------------------------------------------------------------------------------------
; 0000 00A0 // Declare your local variables here
; 0000 00A1 //---------------------------------------------------------------------------------------------------------------------
; 0000 00A2 // type 		        nom 					            dsignation
; 0000 00A3 //---------------------------------------------------------------------------------------------------------------------
; 0000 00A4 // Buffers
; 0000 00A5 char display_buffer[32]; 		                        // Tampon utilis lors de la lecture de la EEPROM
; 0000 00A6 			 		                                    // en page de 32 octets
; 0000 00A7 //---------------------------------------------------------------------------------------------------------------------
; 0000 00A8 unsigned char i, j;                                     // Variable d'ordre gnrale
; 0000 00A9 unsigned char BP;			                            // Reoit le code de la touche actionne
; 0000 00AA unsigned char jour,mois;
; 0000 00AB unsigned int  temp_n,annee;
; 0000 00AC unsigned int  mesure,analogU, analogD, analogC; // Calcul de la ddp dlivre par le pot
; 0000 00AD unsigned char *Transm="";
; 0000 00AE unsigned char rcycl=0, rcycl_1=0;
; 0000 00AF // Coefficient pour le rglage du rapport cyclique du signal PWM
; 0000 00B0 unsigned char alpha[11] = {0,25,51,76,102,127,153,178,204,229,255};
; 0000 00B1 //---------------------------------------------------------------------------------------------------------------------
; 0000 00B2 // Input/Output Ports initialization
; 0000 00B3 // Port A
; 0000 00B4 PORTA=0x3F; // Port A en entre avec rsistance de rappel
	SBIW R28,58
	LDI  R24,14
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x9*2)
	LDI  R31,HIGH(_0x9*2)
	RCALL __INITLOCB
;	display_buffer -> Y+26
;	i -> R17
;	j -> R16
;	BP -> R19
;	jour -> R18
;	mois -> R21
;	temp_n -> Y+24
;	annee -> Y+22
;	mesure -> Y+20
;	analogU -> Y+18
;	analogD -> Y+16
;	analogC -> Y+14
;	*Transm -> Y+12
;	rcycl -> R20
;	rcycl_1 -> Y+11
;	alpha -> Y+0
	LDI  R20,0
	LDI  R30,LOW(63)
	OUT  0x1B,R30
; 0000 00B5 DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
; 0000 00B6 
; 0000 00B7 // Port B
; 0000 00B8 PORTB=0x00; // Port B en sortie
	OUT  0x18,R30
; 0000 00B9 DDRB=0x1F;
	LDI  R30,LOW(31)
	OUT  0x17,R30
; 0000 00BA 
; 0000 00BB // Port C
; 0000 00BC PORTC=0x00; // Port C en sortie
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 00BD DDRC=0xFF;  // Partag entre le LCD et le Buzzer(PORTC.3)
	LDI  R30,LOW(255)
	OUT  0x14,R30
; 0000 00BE 
; 0000 00BF // Port D initialization
; 0000 00C0 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=Out Func6=In Func7=In
; 0000 00C1 // State0=T State1=T State2=T State3=T State4=T State5=0 State6=T State7=T
; 0000 00C2 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 00C3 DDRD=0x20;
	LDI  R30,LOW(32)
	OUT  0x11,R30
; 0000 00C4 
; 0000 00C5 // Timer/Counter 1 initialization
; 0000 00C6 // Clock source: System Clock
; 0000 00C7 // Clock value: 8000,000 kHz
; 0000 00C8 // Mode: Ph. correct PWM top=00FFh
; 0000 00C9 // OC1A output: Non-Inv.
; 0000 00CA // OC1B output: Discon.
; 0000 00CB // Noise Canceler: Off
; 0000 00CC // Input Capture on Falling Edge
; 0000 00CD TCCR1A=0x81;
	LDI  R30,LOW(129)
	OUT  0x2F,R30
; 0000 00CE TCCR1B=0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
; 0000 00CF TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 00D0 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00D1 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00D2 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00D3 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00D4 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00D5 
; 0000 00D6 // ADC initialization
; 0000 00D7 // ADC Clock frequency: 62,500 kHz
; 0000 00D8 // ADC Voltage Reference: AREF pin
; 0000 00D9 // ADC High Speed Mode: Off
; 0000 00DA // ADC Auto Trigger Source: None
; 0000 00DB ADMUX=ADC_VREF_TYPE;
	OUT  0x7,R30
; 0000 00DC ADCSRA=0x87;
	LDI  R30,LOW(135)
	OUT  0x6,R30
; 0000 00DD SFIOR&=0xEF;
	IN   R30,0x30
	ANDI R30,0xEF
	OUT  0x30,R30
; 0000 00DE 
; 0000 00DF // USART initialization
; 0000 00E0 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 00E1 // USART Receiver: Off
; 0000 00E2 // USART Transmitter: On
; 0000 00E3 // USART Mode: Asynchronous
; 0000 00E4 // USART Baud rate: 19200
; 0000 00E5 UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 00E6 UCSRB=0x08;
	LDI  R30,LOW(8)
	OUT  0xA,R30
; 0000 00E7 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 00E8 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 00E9 UBRRL=0x19;
	LDI  R30,LOW(25)
	OUT  0x9,R30
; 0000 00EA 
; 0000 00EB // I2C Bus initialization
; 0000 00EC i2c_init();
	RCALL _i2c_init
; 0000 00ED 
; 0000 00EE // DS1621 Thermometer/Thermostat initialization
; 0000 00EF // tlow: 24C
; 0000 00F0 // thigh: 55C
; 0000 00F1 // Tout polarity: 0
; 0000 00F2 ds1621_init(0,24,55,0);
	RCALL SUBOPT_0x0
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(55)
	RCALL SUBOPT_0x1
	RCALL _ds1621_init
; 0000 00F3 
; 0000 00F4 // PCF8583 Real Time Clock initialization
; 0000 00F5 rtc_init(0,0);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x0
	RCALL _rtc_init
; 0000 00F6 
; 0000 00F7 // External Interrupt(s) initialization
; 0000 00F8 // INT0: On
; 0000 00F9 // INT0 Mode: Falling Edge
; 0000 00FA // INT1: Off
; 0000 00FB // INT2: Off
; 0000 00FC GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
; 0000 00FD MCUCR=0x02;
	LDI  R30,LOW(2)
	OUT  0x35,R30
; 0000 00FE MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 00FF GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 0100 //---------------------------------------------------------------------------------------------------------------------
; 0000 0101 // LCD module initialization
; 0000 0102 lcd_init(16);
	RCALL SUBOPT_0x2
	RCALL _lcd_init
; 0000 0103 //---------------------------------------------------------------------------------------------------------------------
; 0000 0104 // Chargement initial de la mmoire CGRAM de l'afficheur avec les
; 0000 0105 // caractres personaliss
; 0000 0106 for (i=0;i<8;i++)
	LDI  R17,LOW(0)
_0xB:
	CPI  R17,8
	BRSH _0xC
; 0000 0107 {
; 0000 0108 lcd_write_byte(Add_FlecheH_CGRAM + i, flecheHaut[i]); // @1 Caractre flche haut
	MOV  R30,R17
	SUBI R30,-LOW(64)
	RCALL SUBOPT_0x3
	SUBI R30,LOW(-_flecheHaut*2)
	SBCI R31,HIGH(-_flecheHaut*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _lcd_write_byte
; 0000 0109 lcd_write_byte(Add_FlecheB_CGRAM + i, flecheBas[i]); // @2 Caractre flche bas
	MOV  R30,R17
	SUBI R30,-LOW(72)
	RCALL SUBOPT_0x3
	SUBI R30,LOW(-_flecheBas*2)
	SBCI R31,HIGH(-_flecheBas*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _lcd_write_byte
; 0000 010A }
	SUBI R17,-1
	RJMP _0xB
_0xC:
; 0000 010B //---------------------------------------------------------------------------------------------------------------------
; 0000 010C sprintf(display_buffer_ligne0," Test carte SSI ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,1
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
; 0000 010D sprintf(display_buffer_ligne1,"   23/03/2011   ");
	RCALL SUBOPT_0x7
	__POINTW1FN _0x0,18
	RCALL SUBOPT_0x8
; 0000 010E Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 010F delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0x9
; 0000 0110 //---------------------------------------------------------------------------------------------------------------------
; 0000 0111 // Global enable interrupts
; 0000 0112 #asm("sei")
	sei
; 0000 0113 //---------------------------------------------------------------------------------------------------------------------
; 0000 0114 
; 0000 0115 while (1)
_0xD:
; 0000 0116       {		   // Dbut While(1)
; 0000 0117 
; 0000 0118       BP = Lire_BP();
	RCALL _Lire_BP
	MOV  R19,R30
; 0000 0119 
; 0000 011A       switch (etat)
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xB
; 0000 011B        {               // Dbut switch (etat)
; 0000 011C         case LedBP :   if (etat_1 != etat)
	SBIW R30,0
	BRNE _0x13
	RCALL SUBOPT_0xC
	BREQ _0x14
; 0000 011D                         {
; 0000 011E                          sprintf(display_buffer_ligne0,menu_BP);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_BP*2)
	LDI  R31,HIGH(_menu_BP*2)
	RCALL SUBOPT_0x8
; 0000 011F                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 0120                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 0121                          Affiche_fleches();
; 0000 0122                         }
; 0000 0123 
; 0000 0124                         switch(BP)
_0x14:
	RCALL SUBOPT_0xF
; 0000 0125         		        {
; 0000 0126         		            case INC : etat = LedTOR; break;
	BRNE _0x18
	LDI  R30,LOW(1)
	RJMP _0xC6
; 0000 0127         		            case DEC : etat = CLAV_PC; break;
_0x18:
	RCALL SUBOPT_0x10
	BRNE _0x19
	LDI  R30,LOW(11)
	RJMP _0xC6
; 0000 0128         		            case ENTR:  Led_BP_TOR(0); //test des BP
_0x19:
	RCALL SUBOPT_0x11
	BRNE _0x1B
	RCALL SUBOPT_0x0
	RCALL _Led_BP_TOR
; 0000 0129        		      			            sprintf(display_buffer_ligne0,menu_BP);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_BP*2)
	LDI  R31,HIGH(_menu_BP*2)
	RCALL SUBOPT_0x8
; 0000 012A                   			            sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 012B                      			        Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 012C                      			        Affiche_fleches();
; 0000 012D                             break;
	RJMP _0x17
; 0000 012E         		        default  : etat = LedBP;
_0x1B:
	LDI  R30,LOW(0)
_0xC6:
	STS  _etat,R30
; 0000 012F         		        }
_0x17:
; 0000 0130 
; 0000 0131        			        etat_1 = LedBP;
	LDI  R30,LOW(0)
	RJMP _0xC7
; 0000 0132         break;
; 0000 0133 //---------------------------------------------------------------------------------------------------------------------
; 0000 0134         case LedTOR : if (etat_1 != etat)
_0x13:
	RCALL SUBOPT_0x12
	BRNE _0x1C
	RCALL SUBOPT_0xC
	BREQ _0x1D
; 0000 0135                         {
; 0000 0136                          sprintf(display_buffer_ligne0,menu_TOR);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_TOR*2)
	LDI  R31,HIGH(_menu_TOR*2)
	RCALL SUBOPT_0x8
; 0000 0137                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 0138                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 0139                          Affiche_fleches();
; 0000 013A                         }
; 0000 013B 
; 0000 013C                         switch(BP)
_0x1D:
	RCALL SUBOPT_0xF
; 0000 013D         		        {
; 0000 013E         		            case INC : etat = Buzzer; break;
	BRNE _0x21
	LDI  R30,LOW(6)
	RJMP _0xC8
; 0000 013F         		            case DEC : etat = LedBP; break;
_0x21:
	RCALL SUBOPT_0x10
	BRNE _0x22
	LDI  R30,LOW(0)
	RJMP _0xC8
; 0000 0140         		            case ENTR:  Led_BP_TOR(1); // test des entres TOR
_0x22:
	RCALL SUBOPT_0x11
	BRNE _0x24
	RCALL SUBOPT_0x13
	RCALL _Led_BP_TOR
; 0000 0141        		      			            sprintf(display_buffer_ligne0,menu_TOR);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_TOR*2)
	LDI  R31,HIGH(_menu_TOR*2)
	RCALL SUBOPT_0x8
; 0000 0142                   			            sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 0143                      			        Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 0144                      			        Affiche_fleches();
; 0000 0145                             break;
	RJMP _0x20
; 0000 0146         		            default  : etat = LedTOR;
_0x24:
	LDI  R30,LOW(1)
_0xC8:
	STS  _etat,R30
; 0000 0147         		        }
_0x20:
; 0000 0148 
; 0000 0149        			        etat_1 = LedTOR;
	LDI  R30,LOW(1)
	RJMP _0xC7
; 0000 014A         break;
; 0000 014B //---------------------------------------------------------------------------------------------------------------------
; 0000 014C         case Buzzer:	if (etat_1 != etat)
_0x1C:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x25
	RCALL SUBOPT_0xC
	BREQ _0x26
; 0000 014D                         {
; 0000 014E                          sprintf(display_buffer_ligne0,menu_Buzzer);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_Buzzer*2)
	LDI  R31,HIGH(_menu_Buzzer*2)
	RCALL SUBOPT_0x8
; 0000 014F                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 0150                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 0151                          Affiche_fleches();
; 0000 0152                         }
; 0000 0153 
; 0000 0154         		        switch(BP)
_0x26:
	RCALL SUBOPT_0xF
; 0000 0155         		        {
; 0000 0156         		            case INC : etat = Analog; break;
	BRNE _0x2A
	LDI  R30,LOW(2)
	RJMP _0xC9
; 0000 0157         		            case DEC : etat = LedTOR; break;
_0x2A:
	RCALL SUBOPT_0x10
	BRNE _0x2C
	LDI  R30,LOW(1)
	RJMP _0xC9
; 0000 0158         		            default  : etat = Buzzer;
_0x2C:
	LDI  R30,LOW(6)
_0xC9:
	STS  _etat,R30
; 0000 0159         		        }
; 0000 015A 
; 0000 015B        			        PORTC.3 = !PINA.0;
	SBIS 0x19,0
	RJMP _0x2D
	CBI  0x15,3
	RJMP _0x2E
_0x2D:
	SBI  0x15,3
_0x2E:
; 0000 015C        			        etat_1 = Buzzer;
	LDI  R30,LOW(6)
	RJMP _0xC7
; 0000 015D         break;
; 0000 015E //---------------------------------------------------------------------------------------------------------------------
; 0000 015F         case Analog :  	if (etat_1 != etat)
_0x25:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2F
	RCALL SUBOPT_0xC
	BREQ _0x30
; 0000 0160                         {
; 0000 0161                          sprintf(display_buffer_ligne0,menu_Analog);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_Analog*2)
	LDI  R31,HIGH(_menu_Analog*2)
	RCALL SUBOPT_0x8
; 0000 0162                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 0163                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 0164                          Affiche_fleches();
; 0000 0165                         }
; 0000 0166 
; 0000 0167                         switch(BP)
_0x30:
	RCALL SUBOPT_0xF
; 0000 0168                          {
; 0000 0169         		            case INC : etat = Temperature; break;
	BRNE _0x34
	LDI  R30,LOW(3)
	RJMP _0xCA
; 0000 016A         		            case DEC : etat = Buzzer; break;
_0x34:
	RCALL SUBOPT_0x10
	BRNE _0x35
	LDI  R30,LOW(6)
	RJMP _0xCA
; 0000 016B         		            case ENTR: sprintf(display_buffer_ligne1,menu_ECHAP);
_0x35:
	RCALL SUBOPT_0x11
	BREQ PC+2
	RJMP _0x3A
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x14
; 0000 016C 
; 0000 016D        		      			while (BP != ECHAP)
_0x37:
	CPI  R19,59
	BRNE PC+2
	RJMP _0x39
; 0000 016E        		       			{
; 0000 016F        		       			 BP = Lire_BP();
	RCALL _Lire_BP
	MOV  R19,R30
; 0000 0170        		       			 delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x9
; 0000 0171        		       			 mesure = (read_adc(6)/4); // Mesure et calcul de la ddp
	RCALL SUBOPT_0x15
	RCALL _read_adc
	RCALL __LSRW2
	STD  Y+20,R30
	STD  Y+20+1,R31
; 0000 0172        		       			 analogU = ((mesure*5)/255);
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	STD  Y+18,R30
	STD  Y+18+1,R31
; 0000 0173        		       			 analogD = ((10*((mesure - (analogU*255)/5))*5)/255);
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x1B
; 0000 0174        		       			 analogC = ((100*(mesure - (analogU*255)/5 -(analogD*255)/50)*5)/255);
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
	SUB  R26,R30
	SBC  R27,R31
	__PUTW2R 23,24
	RCALL SUBOPT_0x1C
	LDI  R30,LOW(255)
	RCALL SUBOPT_0x16
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __DIVW21U
	MOVW R26,R30
	__GETW1R 23,24
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	RCALL SUBOPT_0x1A
	STD  Y+14,R30
	STD  Y+14+1,R31
; 0000 0175        		       			 sprintf(display_buffer_ligne0,"  DDP = %-u.%-u%-uV",analogU, analogD, analogC);
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,35
	RCALL SUBOPT_0x5
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	RCALL SUBOPT_0x1D
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x1D
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1E
; 0000 0176        		       			 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 0177        		       			}
	RJMP _0x37
_0x39:
; 0000 0178 
; 0000 0179        		       			sprintf(display_buffer_ligne0,menu_Analog);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_Analog*2)
	LDI  R31,HIGH(_menu_Analog*2)
	RCALL SUBOPT_0x8
; 0000 017A                     		sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 017B                         	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 017C        		             break;
	RJMP _0x33
; 0000 017D 
; 0000 017E        			         default  : etat = Analog;
_0x3A:
	LDI  R30,LOW(2)
_0xCA:
	STS  _etat,R30
; 0000 017F        			        }
_0x33:
; 0000 0180 
; 0000 0181        			        etat_1 = Analog;
	LDI  R30,LOW(2)
	RJMP _0xC7
; 0000 0182         break;
; 0000 0183 //---------------------------------------------------------------------------------------------------------------------
; 0000 0184         case Temperature :  temp_n = ds1621_temperature_10(0); // Affichage de la temprature toutes les secondes
_0x2F:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x3B
	RCALL SUBOPT_0x0
	RCALL _ds1621_temperature_10
	STD  Y+24,R30
	STD  Y+24+1,R31
; 0000 0185         	                rtc_get_time(adresse_HTR,&heures,&minutes,&secondes,&dizieme);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1F
; 0000 0186 
; 0000 0187         	       	        if ((etat_1 != etat) || (secondes_1 != secondes))
	BRNE _0x3D
	CP   R7,R6
	BREQ _0x3C
_0x3D:
; 0000 0188         		            {
; 0000 0189         		                sprintf(display_buffer_ligne0,"Capteur DS1621  ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,55
	RCALL SUBOPT_0x8
; 0000 018A         		                sprintf(display_buffer_ligne1,"Temp. = %-i.%-u%-cC",temp_n/10,abs(temp_n%10),0xdf);
	RCALL SUBOPT_0x7
	__POINTW1FN _0x0,72
	RCALL SUBOPT_0x5
	LDD  R26,Y+28
	LDD  R27,Y+28+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	RCALL SUBOPT_0x1D
	LDD  R26,Y+32
	LDD  R27,Y+32+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	RCALL SUBOPT_0x5
	RCALL _abs
	RCALL SUBOPT_0x1D
	__GETD1N 0xDF
	RCALL __PUTPARD1
	RCALL SUBOPT_0x1E
; 0000 018B         		                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 018C         	                    secondes_1 = secondes;
	MOV  R6,R7
; 0000 018D         	                    Affiche_fleches();
	RCALL _Affiche_fleches
; 0000 018E         	                }
; 0000 018F 
; 0000 0190         	                switch(BP)
_0x3C:
	RCALL SUBOPT_0xF
; 0000 0191         		            {
; 0000 0192         		                case INC : etat = EEPROM; break;
	BRNE _0x42
	LDI  R30,LOW(7)
	RJMP _0xCB
; 0000 0193         		                case DEC : etat = Analog; break;
_0x42:
	RCALL SUBOPT_0x10
	BRNE _0x44
	LDI  R30,LOW(2)
	RJMP _0xCB
; 0000 0194         		                default  : etat = Temperature;
_0x44:
	LDI  R30,LOW(3)
_0xCB:
	STS  _etat,R30
; 0000 0195         		            }
; 0000 0196 
; 0000 0197         		            etat_1 = Temperature;
	LDI  R30,LOW(3)
	RJMP _0xC7
; 0000 0198         break;
; 0000 0199 //---------------------------------------------------------------------------------------------------------------------
; 0000 019A         case EEPROM:	if (etat_1 != etat)
_0x3B:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x45
	RCALL SUBOPT_0xC
	BREQ _0x46
; 0000 019B                         {
; 0000 019C                          sprintf(display_buffer_ligne0,menu_EEPROM);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_EEPROM*2)
	LDI  R31,HIGH(_menu_EEPROM*2)
	RCALL SUBOPT_0x8
; 0000 019D                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 019E                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 019F                          Affiche_fleches();
; 0000 01A0                         }
; 0000 01A1 
; 0000 01A2                         switch(BP)
_0x46:
	RCALL SUBOPT_0xF
; 0000 01A3         		        {
; 0000 01A4         		            case INC : etat = Horloge; break;
	BRNE _0x4A
	LDI  R30,LOW(5)
	RJMP _0xCC
; 0000 01A5         		            case DEC : etat = Temperature; break;
_0x4A:
	RCALL SUBOPT_0x10
	BRNE _0x4B
	LDI  R30,LOW(3)
	RJMP _0xCC
; 0000 01A6         		            case ENTR: j=0;
_0x4B:
	RCALL SUBOPT_0x11
	BRNE _0x50
	LDI  R16,LOW(0)
; 0000 01A7 
; 0000 01A8        		      		    for (i=0;i<8;i++)
	LDI  R17,LOW(0)
_0x4E:
	CPI  R17,8
	BRSH _0x4F
; 0000 01A9 					        {
; 0000 01AA  					            lcd_clear();
	RCALL _lcd_clear
; 0000 01AB  					            eeprom_page_read(0xae,j,display_buffer); // EEPROM  l'@AE
	LDI  R30,LOW(174)
	ST   -Y,R30
	MOV  R30,R16
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x5
	MOVW R30,R28
	ADIW R30,29
	RCALL SUBOPT_0x5
	RCALL _eeprom_page_read
; 0000 01AC  					            lcd_puts(display_buffer);
	MOVW R30,R28
	ADIW R30,26
	RCALL SUBOPT_0x5
	RCALL _lcd_puts
; 0000 01AD  					            delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x9
; 0000 01AE  					            j=j+32;
	SUBI R16,-LOW(32)
; 0000 01AF 					        }
	SUBI R17,-1
	RJMP _0x4E
_0x4F:
; 0000 01B0 
; 0000 01B1         		            default  : etat = EEPROM;
_0x50:
	LDI  R30,LOW(7)
_0xCC:
	STS  _etat,R30
; 0000 01B2         		        }
; 0000 01B3 
; 0000 01B4        			        etat_1 = EEPROM;
	LDI  R30,LOW(7)
	RJMP _0xC7
; 0000 01B5         break;
; 0000 01B6 //---------------------------------------------------------------------------------------------------------------------
; 0000 01B7         case Horloge :  rtc_get_time(adresse_HTR,&heures,&minutes,&secondes,&dizieme);
_0x45:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x51
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1F
; 0000 01B8 
; 0000 01B9         		        if ((etat_1 != etat) || (secondes_1 != secondes))
	BRNE _0x53
	CP   R7,R6
	BREQ _0x52
_0x53:
; 0000 01BA         		        {
; 0000 01BB         		            rtc_get_date(adresse_HTR,&jour,&mois,&annee);
	RCALL SUBOPT_0x0
	IN   R30,SPL
	IN   R31,SPH
	RCALL SUBOPT_0x5
	PUSH R18
	IN   R30,SPL
	IN   R31,SPH
	RCALL SUBOPT_0x5
	PUSH R21
	MOVW R30,R28
	ADIW R30,27
	RCALL SUBOPT_0x5
	RCALL _rtc_get_date
	POP  R21
	POP  R18
; 0000 01BC         		            sprintf(display_buffer_ligne0," %-u / %-u / %-i",jour,mois,annee);
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,92
	RCALL SUBOPT_0x5
	MOV  R30,R18
	RCALL SUBOPT_0x20
	MOV  R30,R21
	RCALL SUBOPT_0x20
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x21
; 0000 01BD         		            sprintf(display_buffer_ligne1,"%-uh / %-umn / %-us ",heures, minutes, secondes);
	RCALL SUBOPT_0x7
	__POINTW1FN _0x0,109
	RCALL SUBOPT_0x5
	MOV  R30,R5
	RCALL SUBOPT_0x20
	MOV  R30,R4
	RCALL SUBOPT_0x20
	MOV  R30,R7
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x1E
; 0000 01BE         		            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 01BF         	                secondes_1 = secondes;
	MOV  R6,R7
; 0000 01C0         	                Affiche_fleches();
	RCALL _Affiche_fleches
; 0000 01C1         	            }
; 0000 01C2 
; 0000 01C3         		        switch(BP)
_0x52:
	RCALL SUBOPT_0xF
; 0000 01C4         		        {
; 0000 01C5         		            case INC : etat = RS232Tx; break;
	BRNE _0x58
	LDI  R30,LOW(8)
	RJMP _0xCD
; 0000 01C6         		            case DEC : etat = EEPROM; break;
_0x58:
	RCALL SUBOPT_0x10
	BRNE _0x59
	LDI  R30,LOW(7)
	RJMP _0xCD
; 0000 01C7         		            case ENTR : etat = Reglage_HTR; break;
_0x59:
	RCALL SUBOPT_0x11
	BRNE _0x5B
	LDI  R30,LOW(4)
	RJMP _0xCD
; 0000 01C8         		            default : etat = Horloge;
_0x5B:
	LDI  R30,LOW(5)
_0xCD:
	STS  _etat,R30
; 0000 01C9         		        }
; 0000 01CA 
; 0000 01CB         		        etat_1 = Horloge;
	LDI  R30,LOW(5)
	RJMP _0xC7
; 0000 01CC         break;
; 0000 01CD //---------------------------------------------------------------------------------------------------------------------
; 0000 01CE         case Reglage_HTR : if (etat_1 != etat)
_0x51:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x5C
	RCALL SUBOPT_0xC
	BREQ _0x5D
; 0000 01CF                            {
; 0000 01D0         	                sprintf(display_buffer_ligne0,"  Reglage HTR");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,130
	RCALL SUBOPT_0x8
; 0000 01D1         	                sprintf(display_buffer_ligne1,"SET>H ETR>Date ");
	RCALL SUBOPT_0x7
	__POINTW1FN _0x0,144
	RCALL SUBOPT_0x8
; 0000 01D2         	                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 01D3         		            }
; 0000 01D4 
; 0000 01D5         	               switch(BP)
_0x5D:
	MOV  R30,R19
	RCALL SUBOPT_0xB
; 0000 01D6         		            {
; 0000 01D7         		                case SET:   Heure_ou_Date = 0;
	CPI  R30,LOW(0x3D)
	LDI  R26,HIGH(0x3D)
	CPC  R31,R26
	BRNE _0x61
	CLR  R8
; 0000 01D8         		  	                        H_J = 12;
	LDI  R30,LOW(12)
	MOV  R11,R30
; 0000 01D9         		  	                        mn_mois = 30;
	LDI  R30,LOW(30)
	MOV  R10,R30
; 0000 01DA         		  	                        sec_annee = 0;
	CLR  R12
	CLR  R13
; 0000 01DB         		  	                        RegleHTR(adresse_HTR,Heure_ou_Date,H_J,mn_mois,sec_annee);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x22
; 0000 01DC         		  	                        etat = Horloge;
	RJMP _0xCE
; 0000 01DD         		                break;
; 0000 01DE 
; 0000 01DF         		                case ENTR : Heure_ou_Date = 1;
_0x61:
	RCALL SUBOPT_0x11
	BRNE _0x63
	LDI  R30,LOW(1)
	MOV  R8,R30
; 0000 01E0         		  	                        H_J = 15;
	LDI  R30,LOW(15)
	MOV  R11,R30
; 0000 01E1         		  	                        mn_mois = 6;
	LDI  R30,LOW(6)
	MOV  R10,R30
; 0000 01E2         		  	                        sec_annee = 2008;
	LDI  R30,LOW(2008)
	LDI  R31,HIGH(2008)
	MOVW R12,R30
; 0000 01E3         		  	                        RegleHTR(adresse_HTR,Heure_ou_Date,H_J,mn_mois,sec_annee);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x22
; 0000 01E4         		  	                        etat = Horloge;
	RJMP _0xCE
; 0000 01E5         		                break;
; 0000 01E6 
; 0000 01E7         		                default:     etat = Reglage_HTR;
_0x63:
	LDI  R30,LOW(4)
_0xCE:
	STS  _etat,R30
; 0000 01E8         		            }
; 0000 01E9 
; 0000 01EA                             etat_1 = Reglage_HTR;
	LDI  R30,LOW(4)
	RJMP _0xC7
; 0000 01EB         break;
; 0000 01EC //---------------------------------------------------------------------------------------------------------------------
; 0000 01ED         case RS232Tx:	if (etat_1 != etat)
_0x5C:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x64
	RCALL SUBOPT_0xC
	BREQ _0x65
; 0000 01EE                         {
; 0000 01EF                          sprintf(display_buffer_ligne0,menu_RS232);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_RS232*2)
	LDI  R31,HIGH(_menu_RS232*2)
	RCALL SUBOPT_0x8
; 0000 01F0                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 01F1                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 01F2                          Affiche_fleches();
; 0000 01F3                         }
; 0000 01F4 
; 0000 01F5                         switch(BP)
_0x65:
	RCALL SUBOPT_0xF
; 0000 01F6         		        {
; 0000 01F7         		            case INC : etat = MOT_PWM; break;
	BRNE _0x69
	LDI  R30,LOW(9)
	RJMP _0xCF
; 0000 01F8         		            case DEC : etat = Horloge; break;
_0x69:
	RCALL SUBOPT_0x10
	BRNE _0x6A
	LDI  R30,LOW(5)
	RJMP _0xCF
; 0000 01F9         		            case ENTR:  rtc_get_time(adresse_HTR,&heures,&minutes,&secondes,&dizieme);
_0x6A:
	RCALL SUBOPT_0x11
	BRNE _0x6C
	RCALL SUBOPT_0x0
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x5
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0x5
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RCALL SUBOPT_0x5
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RCALL SUBOPT_0x5
	RCALL _rtc_get_time
; 0000 01FA         		                        sprintf(Transm,"%u/%u/%u",heures, minutes, secondes);
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	RCALL SUBOPT_0x5
	__POINTW1FN _0x0,160
	RCALL SUBOPT_0x5
	MOV  R30,R5
	RCALL SUBOPT_0x20
	MOV  R30,R4
	RCALL SUBOPT_0x20
	MOV  R30,R7
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x21
; 0000 01FB         		                        puts(Transm);
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	RCALL SUBOPT_0x5
	RCALL _puts
; 0000 01FC         		            break;
	RJMP _0x68
; 0000 01FD         		            default  : etat = RS232Tx;
_0x6C:
	LDI  R30,LOW(8)
_0xCF:
	STS  _etat,R30
; 0000 01FE         		        }
_0x68:
; 0000 01FF 
; 0000 0200        			        etat_1 = RS232Tx;
	LDI  R30,LOW(8)
	RJMP _0xC7
; 0000 0201         break;
; 0000 0202 //---------------------------------------------------------------------------------------------------------------------
; 0000 0203         case MOT_PWM :	if (etat_1 != etat)
_0x64:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x6D
	RCALL SUBOPT_0xC
	BREQ _0x6E
; 0000 0204                         {
; 0000 0205                          sprintf(display_buffer_ligne0,menu_PWM);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_PWM*2)
	LDI  R31,HIGH(_menu_PWM*2)
	RCALL SUBOPT_0x8
; 0000 0206                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 0207                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 0208                          Affiche_fleches();
; 0000 0209                         }
; 0000 020A 
; 0000 020B                         switch(BP)
_0x6E:
	RCALL SUBOPT_0xF
; 0000 020C         		        {
; 0000 020D         		            case INC : etat = CLAV_PC; break;
	BRNE _0x72
	LDI  R30,LOW(11)
	RJMP _0xD0
; 0000 020E         		            case DEC : etat = RS232Tx; break;
_0x72:
	RCALL SUBOPT_0x10
	BRNE _0x73
	LDI  R30,LOW(8)
	RJMP _0xD0
; 0000 020F         		            case ENTR: etat = REG_PWM; break;
_0x73:
	RCALL SUBOPT_0x11
	BRNE _0x75
	LDI  R30,LOW(10)
	RJMP _0xD0
; 0000 0210         		            default  : etat = MOT_PWM;
_0x75:
	LDI  R30,LOW(9)
_0xD0:
	STS  _etat,R30
; 0000 0211         		        }
; 0000 0212 
; 0000 0213        			        etat_1 = MOT_PWM;
	LDI  R30,LOW(9)
	RJMP _0xC7
; 0000 0214         break;
; 0000 0215 //---------------------------------------------------------------------------------------------------------------------
; 0000 0216         case REG_PWM :  if ((etat_1 != etat)|| (rcycl_1 != rcycl))
_0x6D:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x76
	RCALL SUBOPT_0xC
	BRNE _0x78
	LDD  R26,Y+11
	CP   R20,R26
	BREQ _0x77
_0x78:
; 0000 0217        			        {
; 0000 0218        		   	            sprintf(display_buffer_ligne0,"Rap. cycl = %-u%%",rcycl);
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,169
	RCALL SUBOPT_0x5
	MOV  R30,R20
	RCALL SUBOPT_0x20
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
; 0000 0219        		                sprintf(display_buffer_ligne1,"INC>+ DEC>- ESc>");
	RCALL SUBOPT_0x7
	__POINTW1FN _0x0,187
	RCALL SUBOPT_0x8
; 0000 021A        		                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 021B        		                rcycl_1 = rcycl;
	__PUTBSR 20,11
; 0000 021C 			            }
; 0000 021D 
; 0000 021E 		                switch(BP)
_0x77:
	RCALL SUBOPT_0xF
; 0000 021F 			            {
; 0000 0220 				            case INC: if (rcycl < 90) rcycl = rcycl+10; else rcycl = 100; break;
	BRNE _0x7D
	CPI  R20,90
	BRSH _0x7E
	SUBI R20,-LOW(10)
	RJMP _0x7F
_0x7E:
	LDI  R20,LOW(100)
_0x7F:
	RJMP _0x7C
; 0000 0221 				            case DEC: if (rcycl > 10) rcycl = rcycl-10; else rcycl = 0; break;
_0x7D:
	RCALL SUBOPT_0x10
	BRNE _0x80
	CPI  R20,11
	BRLO _0x81
	MOV  R30,R20
	RCALL SUBOPT_0xB
	SBIW R30,10
	MOV  R20,R30
	RJMP _0x82
_0x81:
	LDI  R20,LOW(0)
_0x82:
	RJMP _0x7C
; 0000 0222 				            case ECHAP : rcycl = 0; etat = MOT_PWM; break;
_0x80:
	RCALL SUBOPT_0x23
	BRNE _0x84
	LDI  R20,LOW(0)
	LDI  R30,LOW(9)
	RJMP _0xD1
; 0000 0223 				            default: etat = REG_PWM;
_0x84:
	LDI  R30,LOW(10)
_0xD1:
	STS  _etat,R30
; 0000 0224                         }
_0x7C:
; 0000 0225 
; 0000 0226 			            OCR1AL=alpha[rcycl/10];
	MOV  R26,R20
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	MOVW R26,R28
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	OUT  0x2A,R30
; 0000 0227          		        etat_1 = REG_PWM ;
	LDI  R30,LOW(10)
	RJMP _0xC7
; 0000 0228         break;
; 0000 0229 //---------------------------------------------------------------------------------------------------------------------
; 0000 022A         case CLAV_PC :	if (etat_1 != etat)
_0x76:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x85
	RCALL SUBOPT_0xC
	BREQ _0x86
; 0000 022B                         {
; 0000 022C                          sprintf(display_buffer_ligne0,menu_PC);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(_menu_PC*2)
	LDI  R31,HIGH(_menu_PC*2)
	RCALL SUBOPT_0x8
; 0000 022D                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 022E                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xE
; 0000 022F                          Affiche_fleches();
; 0000 0230                         }
; 0000 0231 
; 0000 0232                         switch(BP)
_0x86:
	RCALL SUBOPT_0xF
; 0000 0233         		        {
; 0000 0234         		            case INC : etat = LedBP; break;
	BRNE _0x8A
	LDI  R30,LOW(0)
	RJMP _0xD2
; 0000 0235         		            case DEC : etat = MOT_PWM; break;
_0x8A:
	RCALL SUBOPT_0x10
	BRNE _0x8B
	LDI  R30,LOW(9)
	RJMP _0xD2
; 0000 0236         		            case ENTR: etat = REG_TST_CLAV102; break;
_0x8B:
	RCALL SUBOPT_0x11
	BRNE _0x8D
	LDI  R30,LOW(12)
	RJMP _0xD2
; 0000 0237         		            default  : etat = CLAV_PC;
_0x8D:
	LDI  R30,LOW(11)
_0xD2:
	STS  _etat,R30
; 0000 0238         		        }
; 0000 0239 
; 0000 023A        			        etat_1 = CLAV_PC;
	LDI  R30,LOW(11)
	RJMP _0xC7
; 0000 023B         break;
; 0000 023C //---------------------------------------------------------------------------------------------------------------------
; 0000 023D         case REG_TST_CLAV102 :	if (etat_1 != etat)
_0x85:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x8E
	RCALL SUBOPT_0xC
	BREQ _0x8F
; 0000 023E                         {
; 0000 023F                          sprintf(display_buffer_ligne0,"Caval PAO 1-2 OK");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,204
	RCALL SUBOPT_0x8
; 0000 0240                          sprintf(display_buffer_ligne1,menu_ECHAP);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x14
; 0000 0241                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 0242                         }
; 0000 0243 
; 0000 0244                         switch(BP)
_0x8F:
	MOV  R30,R19
	RCALL SUBOPT_0xB
; 0000 0245         		        {
; 0000 0246         		            case OK : etat = TST_CLAV_102T; break;
	RCALL SUBOPT_0x24
	BRNE _0x93
	LDI  R30,LOW(13)
	RJMP _0xD3
; 0000 0247         		            case ECHAP: etat = CLAV_PC; break;
_0x93:
	RCALL SUBOPT_0x23
	BRNE _0x95
	LDI  R30,LOW(11)
	RJMP _0xD3
; 0000 0248         		            default  : etat = REG_TST_CLAV102;
_0x95:
	LDI  R30,LOW(12)
_0xD3:
	STS  _etat,R30
; 0000 0249         		        }
; 0000 024A 
; 0000 024B        			        etat_1 = REG_TST_CLAV102;
	LDI  R30,LOW(12)
	RJMP _0xC7
; 0000 024C         break;
; 0000 024D //---------------------------------------------------------------------------------------------------------------------
; 0000 024E // Ecriture du caractre reu du clavier 102 touches sur la premire ligne de l'afficheur de la carte SSI.
; 0000 024F // Lorsque le curseur arrive   la fin de la ligne, celle-ci est efface et l'criture reprend au dbut.
; 0000 0250 //---------------------------------------------------------------------------------------------------------------------
; 0000 0251         case TST_CLAV_102T : if (etat_1 != etat)
_0x8E:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0x12
	RCALL SUBOPT_0xC
	BREQ _0x97
; 0000 0252                        {
; 0000 0253                         sprintf(display_buffer_ligne0,"                ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,221
	RCALL SUBOPT_0x8
; 0000 0254                     	sprintf(display_buffer_ligne1,menu_ECHAP);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x14
; 0000 0255                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 0256                     	lcd_gotoxy(0,0);_lcd_write_data(displayOn3); i =0;
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x25
; 0000 0257                        }
; 0000 0258 
; 0000 0259                       if (g_flag_char == VRAI)
_0x97:
	SBRS R2,0
	RJMP _0x98
; 0000 025A                        {
; 0000 025B                          if (i<16)
	CPI  R17,16
	BRSH _0x99
; 0000 025C                          {
; 0000 025D                          	lcd_putchar(g_key_ASCII);
	LDS  R30,_g_key_ASCII
	ST   -Y,R30
	RCALL _lcd_putchar
; 0000 025E                          	i++;
	SUBI R17,-1
; 0000 025F                          }
; 0000 0260                          else
	RJMP _0x9A
_0x99:
; 0000 0261                          	{
; 0000 0262                          	  sprintf(display_buffer_ligne0,"                ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,221
	RCALL SUBOPT_0x8
; 0000 0263                        		  sprintf(display_buffer_ligne1,menu_ECHAP);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x14
; 0000 0264                     		  Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 0265                     		  lcd_gotoxy(0,0);_lcd_write_data(displayOn3); i = 0;
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x25
; 0000 0266                          	}
_0x9A:
; 0000 0267 
; 0000 0268                          g_flag_char = FAUX;
	CLT
	BLD  R2,0
; 0000 0269                        }
; 0000 026A 
; 0000 026B                       switch(BP)
_0x98:
	MOV  R30,R19
	RCALL SUBOPT_0xB
; 0000 026C         		        {
; 0000 026D         		            case ECHAP: etat = CLAV_PC; break;
	RCALL SUBOPT_0x23
	BRNE _0x9F
	LDI  R30,LOW(11)
	RJMP _0xD4
; 0000 026E         		            default  : etat = TST_CLAV_102T;
_0x9F:
	LDI  R30,LOW(13)
_0xD4:
	STS  _etat,R30
; 0000 026F         		        }
; 0000 0270 
; 0000 0271        		          etat_1 = TST_CLAV_102T;
	LDI  R30,LOW(13)
_0xC7:
	STS  _etat_1,R30
; 0000 0272        break;
; 0000 0273 //---------------------------------------------------------------------------------------------------------------------
; 0000 0274        }; // Fin switch(etat)
_0x12:
; 0000 0275 //---------------------------------------------------------------------------------------------------------------------
; 0000 0276       }  // Fin while(1)
	RJMP _0xD
; 0000 0277 //---------------------------------------------------------------------------------------------------------------------
; 0000 0278 } // Fin main()
_0xA0:
	RJMP _0xA0

	.DSEG
_0x8:
	.BYTE 0x1
;//=====================================================================================================================
;
;//=====================================================================================================================
;// Sous-programmes
;//---------------------------------------------------------------------------------------------------------------------
;void Affiche_fleches(void)
; 0000 027F {

	.CSEG
_Affiche_fleches:
; 0000 0280 lcd_gotoxy(15,0);	// Affichage flecheHaut
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x1
	RCALL _lcd_gotoxy
; 0000 0281 lcd_putchar(Caractere_FlecheH);
	RCALL SUBOPT_0x0
	RCALL _lcd_putchar
; 0000 0282 lcd_gotoxy(15,1);	// Affichage flecheBas
	LDI  R30,LOW(15)
	ST   -Y,R30
	RCALL SUBOPT_0x13
	RCALL _lcd_gotoxy
; 0000 0283 lcd_putchar(Caractere_FlecheB);
	RCALL SUBOPT_0x13
	RCALL _lcd_putchar
; 0000 0284 }
	RET
;//---------------------------------------------------------------------------------------------------------------------
;int Led_BP_TOR(char entree)
; 0000 0287 {
_Led_BP_TOR:
; 0000 0288   unsigned char BP, Affich=1, sortir=0;
; 0000 0289 
; 0000 028A   if (entree==0)
	RCALL __SAVELOCR4
;	entree -> Y+4
;	BP -> R17
;	Affich -> R16
;	sortir -> R19
	LDI  R16,1
	LDI  R19,0
	LDD  R30,Y+4
	CPI  R30,0
	BRNE _0xA1
; 0000 028B        {
; 0000 028C         sprintf(display_buffer_ligne1,"Sortir = 2xECHAP");
	RCALL SUBOPT_0x7
	__POINTW1FN _0x0,238
	RJMP _0xD5
; 0000 028D     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
; 0000 028E        }
; 0000 028F         else
_0xA1:
; 0000 0290        {
; 0000 0291         sprintf(display_buffer_ligne1,"Sortir = 2xPA2  ");
	RCALL SUBOPT_0x7
	__POINTW1FN _0x0,255
_0xD5:
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x6
; 0000 0292        	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 0293        }
; 0000 0294 
; 0000 0295   while(sortir<2)
_0xA3:
	CPI  R19,2
	BRLO PC+2
	RJMP _0xA5
; 0000 0296   {
; 0000 0297    BP=Lire_BP();
	RCALL _Lire_BP
	MOV  R17,R30
; 0000 0298    switch (BP)
	RCALL SUBOPT_0x26
; 0000 0299       {
; 0000 029A        case INC: PORTB = 0x1F;
	BRNE _0xA9
	LDI  R30,LOW(31)
	OUT  0x18,R30
; 0000 029B        		 sprintf(display_buffer_ligne0,"   PA5 -> ALL   ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,272
	RCALL SUBOPT_0x8
; 0000 029C        		 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x27
; 0000 029D                  Affich = 1;
; 0000 029E                  if (sortir==1) sortir=0;
	BRNE _0xAA
	LDI  R19,LOW(0)
; 0000 029F        break;
_0xAA:
	RJMP _0xA8
; 0000 02A0 
; 0000 02A1        case DEC: PORTB.4 = 1;
_0xA9:
	RCALL SUBOPT_0x10
	BRNE _0xAB
	SBI  0x18,4
; 0000 02A2        		 sprintf(display_buffer_ligne0,"   PA4 -> PB4   ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,289
	RCALL SUBOPT_0x8
; 0000 02A3        	       	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x27
; 0000 02A4                  Affich = 1;
; 0000 02A5                  if (sortir==1) sortir=0;
	BRNE _0xAE
	LDI  R19,LOW(0)
; 0000 02A6        	break;
_0xAE:
	RJMP _0xA8
; 0000 02A7 
; 0000 02A8      	case OK: PORTB.3 = 1;
_0xAB:
	RCALL SUBOPT_0x24
	BRNE _0xAF
	SBI  0x18,3
; 0000 02A9      		 sprintf(display_buffer_ligne0,"   PA3 -> PB3   ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,306
	RCALL SUBOPT_0x8
; 0000 02AA        	       	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x27
; 0000 02AB                  Affich = 1;
; 0000 02AC                  if (sortir==1) sortir=0;
	BRNE _0xB2
	LDI  R19,LOW(0)
; 0000 02AD        	break;
_0xB2:
	RJMP _0xA8
; 0000 02AE 
; 0000 02AF       	case SET:PORTB.1 = 1;
_0xAF:
	CPI  R30,LOW(0x3D)
	LDI  R26,HIGH(0x3D)
	CPC  R31,R26
	BRNE _0xB3
	SBI  0x18,1
; 0000 02B0       		 sprintf(display_buffer_ligne0,"   PA1 -> PB1   ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,323
	RCALL SUBOPT_0x8
; 0000 02B1         	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x27
; 0000 02B2                  Affich = 1;
; 0000 02B3                  if (sortir==1) sortir=0;
	BRNE _0xB6
	LDI  R19,LOW(0)
; 0000 02B4        	break;
_0xB6:
	RJMP _0xA8
; 0000 02B5 
; 0000 02B6       	case ECHAP: PORTB.2 = 1;
_0xB3:
	RCALL SUBOPT_0x23
	BRNE _0xB7
	SBI  0x18,2
; 0000 02B7       	            sprintf(display_buffer_ligne0,"   PA2 -> PB2   ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,340
	RCALL SUBOPT_0x8
; 0000 02B8        	       	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 02B9        		    Affich = 1;
	LDI  R16,LOW(1)
; 0000 02BA        		    sortir = sortir + 1;
	SUBI R19,-LOW(1)
; 0000 02BB        	break;
	RJMP _0xA8
; 0000 02BC 
; 0000 02BD        	case ENTR: PORTB.0 = 1;
_0xB7:
	RCALL SUBOPT_0x11
	BRNE _0xBA
	SBI  0x18,0
; 0000 02BE        		    sprintf(display_buffer_ligne0,"   PA0 -> PB0   ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,357
	RCALL SUBOPT_0x8
; 0000 02BF        	       	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x27
; 0000 02C0                     Affich = 1;
; 0000 02C1                     if (sortir==1) sortir=0;
	BRNE _0xBD
	LDI  R19,LOW(0)
; 0000 02C2        	break;
_0xBD:
	RJMP _0xA8
; 0000 02C3 
; 0000 02C4       	case 0xff: PORTB = 0;
_0xBA:
	CPI  R30,LOW(0xFF)
	LDI  R26,HIGH(0xFF)
	CPC  R31,R26
	BRNE _0xA8
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 02C5       	           if ((Affich == 1)&&(entree==0))
	CPI  R16,1
	BRNE _0xC0
	LDD  R26,Y+4
	CPI  R26,LOW(0x0)
	BREQ _0xC1
_0xC0:
	RJMP _0xBF
_0xC1:
; 0000 02C6        	  	    {
; 0000 02C7        	  	      sprintf(display_buffer_ligne0," Test BPx->DELx");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,374
	RJMP _0xD6
; 0000 02C8        	       	      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
; 0000 02C9        	       	    }
; 0000 02CA        	       	    else if  ((Affich == 1)&&(entree==1))
_0xBF:
	CPI  R16,1
	BRNE _0xC4
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BREQ _0xC5
_0xC4:
	RJMP _0xC3
_0xC5:
; 0000 02CB        	       	    {
; 0000 02CC        	  	      sprintf(display_buffer_ligne0,"Test TORx->DELx");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,390
_0xD6:
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x6
; 0000 02CD        	       	      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
; 0000 02CE        	       	    }
; 0000 02CF        	       	    Affich = 0;
_0xC3:
	LDI  R16,LOW(0)
; 0000 02D0 
; 0000 02D1        	break;
; 0000 02D2        }
_0xA8:
; 0000 02D3   }
	RJMP _0xA3
_0xA5:
; 0000 02D4 PORTB = 0;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 02D5 return 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL __LOADLOCR4
	RJMP _0x2160006
; 0000 02D6 }
;//---------------------------------------------------------------------------------------------------------------------
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
putchar0:
     sbis usr,udre
     rjmp putchar0
     ld   r30,y
     out  udr,r30
	RJMP _0x2160001
_puts:
	ST   -Y,R17
_0x2000003:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RCALL SUBOPT_0x28
	BREQ _0x2000005
	ST   -Y,R17
	RCALL _putchar
	RJMP _0x2000003
_0x2000005:
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _putchar
	RJMP _0x2160003
_put_buff_G100:
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x29
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x2A
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	RCALL SUBOPT_0x29
	ADIW R26,2
	RCALL SUBOPT_0x2B
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	RCALL SUBOPT_0x29
	RCALL __GETW1P
	TST  R31
	BRMI _0x2000014
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x2B
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	RCALL SUBOPT_0x29
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	RCALL __LOADLOCR2
	RJMP _0x2160006
__print_G100:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	RCALL SUBOPT_0x2C
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	RCALL SUBOPT_0x2C
	RJMP _0x20000C9
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x2D
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0x2F
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x32
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x32
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	RCALL SUBOPT_0x33
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	RCALL SUBOPT_0x33
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x34
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x34
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x34
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	RCALL SUBOPT_0x2C
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	RCALL SUBOPT_0x33
	RJMP _0x2000054
_0x2000053:
	RCALL SUBOPT_0x35
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	RCALL SUBOPT_0x2C
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x33
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	RCALL SUBOPT_0x36
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x34
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	RCALL SUBOPT_0x36
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CA
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x2F
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	RCALL SUBOPT_0x2C
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	RCALL SUBOPT_0x36
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x2F
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000C9:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x37
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x216000B
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x33
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x5
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	RCALL SUBOPT_0x5
	MOVW R30,R28
	ADIW R30,10
	RCALL SUBOPT_0x5
	RCALL __print_G100
	MOVW R18,R30
	RCALL SUBOPT_0x35
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x216000B:
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret

	.DSEG

	.CSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_ext_int0_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30

	.DSEG

	.CSEG

	.DSEG

	.CSEG
	ST   -Y,R17
	LDI  R30,0
	SBRC R2,1
	LDI  R30,1
	CPI  R30,0
	BREQ PC+2
	RJMP _0x2060008
	LDS  R30,_edge_S1030000000
	CPI  R30,0
	BRNE _0x2060009
	LDS  R26,_bitcount_RX_S1030000000
	CPI  R26,LOW(0xC)
	BRSH _0x206000B
	CPI  R26,LOW(0x1)
	BRSH _0x206000C
_0x206000B:
	RJMP _0x206000A
_0x206000C:
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x39
	SBIS 0x19,0
	RJMP _0x206000D
	__ORBMNN _g_data_S1030000000,1,128
_0x206000D:
_0x206000A:
	LDI  R30,LOW(3)
	OUT  0x35,R30
	LDI  R30,LOW(1)
	STS  _edge_S1030000000,R30
	RJMP _0x206000E
_0x2060009:
	LDI  R30,LOW(2)
	OUT  0x35,R30
	LDI  R30,LOW(0)
	STS  _edge_S1030000000,R30
	LDS  R30,_bitcount_RX_S1030000000
	SUBI R30,LOW(1)
	STS  _bitcount_RX_S1030000000,R30
	CPI  R30,0
	BREQ PC+2
	RJMP _0x206000F
	LDS  R26,_g_data_S1030000000
	LDS  R27,_g_data_S1030000000+1
	LDI  R30,LOW(5)
	RCALL __LSRW12
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x38
	STS  _g_data_aff_S1030000000,R30
	LDS  R30,_is_up_S1030000000
	CPI  R30,0
	BREQ PC+2
	RJMP _0x2060010
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0xB
	CPI  R30,LOW(0xF0)
	LDI  R26,HIGH(0xF0)
	CPC  R31,R26
	BRNE _0x2060014
	LDI  R30,LOW(1)
	STS  _is_up_S1030000000,R30
	CLT
	RJMP _0x2060035
_0x2060014:
	CPI  R30,LOW(0x12)
	LDI  R26,HIGH(0x12)
	CPC  R31,R26
	BRNE _0x2060015
	LDI  R30,LOW(1)
	STS  _shift_S1030000000,R30
	RJMP _0x2060013
_0x2060015:
	CPI  R30,LOW(0x59)
	LDI  R26,HIGH(0x59)
	CPC  R31,R26
	BRNE _0x2060017
	LDI  R30,LOW(1)
	STS  _shift_S1030000000,R30
	RJMP _0x2060013
_0x2060017:
	LDS  R30,_shift_S1030000000
	CPI  R30,0
	BRNE _0x2060018
	LDI  R17,LOW(0)
_0x206001A:
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3C
	BREQ _0x206001C
	MOVW R30,R0
	LPM  R30,Z
	CPI  R30,0
	BRNE _0x206001D
_0x206001C:
	RJMP _0x206001B
_0x206001D:
	SUBI R17,-1
	RJMP _0x206001A
_0x206001B:
	RCALL SUBOPT_0x3B
	LPM  R26,Z
	RCALL SUBOPT_0x3A
	CP   R30,R26
	BRNE _0x206001E
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3D
	SBRC R2,0
	RJMP _0x206001F
	SET
	BLD  R2,0
_0x206001F:
_0x206001E:
	RJMP _0x2060020
_0x2060018:
	LDI  R17,LOW(0)
_0x2060022:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x3C
	BREQ _0x2060024
	MOVW R30,R0
	LPM  R30,Z
	CPI  R30,0
	BRNE _0x2060025
_0x2060024:
	RJMP _0x2060023
_0x2060025:
	SUBI R17,-1
	RJMP _0x2060022
_0x2060023:
	RCALL SUBOPT_0x3E
	LPM  R26,Z
	RCALL SUBOPT_0x3A
	CP   R30,R26
	BRNE _0x2060026
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x3D
	SBRC R2,0
	RJMP _0x2060027
	SET
_0x2060035:
	BLD  R2,0
_0x2060027:
_0x2060026:
_0x2060020:
_0x2060013:
	RJMP _0x2060028
_0x2060010:
	LDI  R30,LOW(0)
	STS  _is_up_S1030000000,R30
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0xB
	CPI  R30,LOW(0x12)
	LDI  R26,HIGH(0x12)
	CPC  R31,R26
	BREQ _0x2060036
	CPI  R30,LOW(0x59)
	LDI  R26,HIGH(0x59)
	CPC  R31,R26
	BRNE _0x206002B
_0x2060036:
	LDI  R30,LOW(0)
	STS  _shift_S1030000000,R30
_0x206002B:
_0x2060028:
	LDI  R30,LOW(11)
	STS  _bitcount_RX_S1030000000,R30
_0x206000F:
_0x206000E:
	RJMP _0x2060007
_0x2060008:
	CPI  R30,LOW(0x1)
	BRNE _0x2060007
	LDS  R30,_bitcount_TX_S1030000000
	CPI  R30,0
	BREQ _0x206002F
	LDS  R30,_g_Trame_TX
	CPI  R30,0
	BRNE _0x2060030
	CBI  0x19,0
	RJMP _0x2060031
_0x2060030:
	SBI  0x19,0
_0x2060031:
	LDS  R30,_bitcount_TX_S1030000000
	RCALL SUBOPT_0xB
	SBIW R30,1
	STS  _bitcount_TX_S1030000000,R30
	LDS  R30,_g_Trame_TX
	LDS  R31,_g_Trame_TX+1
	LSR  R31
	ROR  R30
	STS  _g_Trame_TX,R30
	STS  _g_Trame_TX+1,R31
	RJMP _0x2060032
_0x206002F:
	LDI  R30,LOW(10)
	STS  _bitcount_TX_S1030000000,R30
	CLT
	BLD  R2,1
	CBI  0x1A,0
_0x2060032:
_0x2060007:
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_Lire_BP:

	.DSEG

	.CSEG
	RCALL __SAVELOCR2
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R16,R30
	LDS  R30,_Etat_BP_S1040000000
	RCALL SUBOPT_0xB
	SBIW R30,0
	BRNE _0x2080007
	CPI  R16,63
	BRNE _0x2080008
	RCALL SUBOPT_0x3F
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R16,R30
	CP   R16,R17
	BRNE _0x2080009
	LDI  R30,LOW(1)
	STS  _Etat_BP_S1040000000,R30
	LDI  R30,LOW(255)
	RJMP _0x216000A
_0x2080009:
	LDI  R30,LOW(0)
	RJMP _0x216000A
_0x2080008:
	LDI  R30,LOW(0)
	RJMP _0x216000A
_0x2080007:
	RCALL SUBOPT_0x12
	BRNE _0x2080006
	CPI  R16,63
	BREQ _0x208000D
	RCALL SUBOPT_0x3F
	ANDI R16,LOW(63)
	CP   R16,R17
	BRNE _0x208000E
	LDI  R30,LOW(0)
	STS  _Etat_BP_S1040000000,R30
	MOV  R30,R16
	RJMP _0x216000A
_0x208000E:
	LDI  R30,LOW(255)
	RJMP _0x216000A
_0x208000D:
	LDI  R30,LOW(255)
_0x2080006:
_0x216000A:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x5
	RCALL _lcd_puts
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x13
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x5
	RCALL _lcd_puts
	RJMP _0x2160008
_eeprom_page_read:
	RCALL __SAVELOCR4
	LDD  R19,Y+6
	LDD  R16,Y+7
	RCALL _i2c_start
	RCALL SUBOPT_0x40
	RCALL _i2c_write
	ST   -Y,R16
	RCALL _i2c_write
	ST   -Y,R19
	RCALL SUBOPT_0x41
	LDD  R30,Y+8
	ORI  R30,1
	RCALL SUBOPT_0x42
	LDI  R17,LOW(0)
_0x2080012:
	CPI  R17,31
	BRSH _0x2080013
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x43
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	STD  Y+4,R26
	STD  Y+4+1,R27
	SUBI R17,-1
	RJMP _0x2080012
_0x2080013:
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x43
	RCALL _i2c_stop
	RCALL __LOADLOCR4
	RJMP _0x2160007
_RegleHTR:
	SBIW R28,35
	LDI  R30,LOW(1)
	ST   Y,R30
	RCALL __SAVELOCR6
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	__GETWRN 20,21,0
	LDI  R18,0
_0x2080014:
	RCALL _Lire_BP
	MOV  R17,R30
	MOV  R30,R18
	RCALL SUBOPT_0xB
	SBIW R30,0
	BREQ PC+2
	RJMP _0x208001A
	RCALL SUBOPT_0x44
	BRNE _0x208001B
	LDD  R30,Y+44
	CP   R30,R16
	BRNE _0x208001D
	RCALL SUBOPT_0x45
	BREQ _0x208001C
_0x208001D:
	RCALL SUBOPT_0x46
	__POINTW1FN _0x2080000,0
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x47
	__POINTW1FN _0x2080000,17
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x46
	RCALL SUBOPT_0x4B
_0x208001C:
	RJMP _0x208001F
_0x208001B:
	LDD  R30,Y+44
	CP   R30,R16
	BRNE _0x2080021
	RCALL SUBOPT_0x45
	BREQ _0x2080020
_0x2080021:
	RCALL SUBOPT_0x46
	__POINTW1FN _0x2080000,37
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x47
	__POINTW1FN _0x2080000,53
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x46
	RCALL SUBOPT_0x4B
_0x2080020:
_0x208001F:
	RCALL SUBOPT_0x26
	BRNE _0x2080026
	LDD  R30,Y+44
	SUBI R30,-LOW(1)
	STD  Y+44,R30
	RCALL SUBOPT_0x44
	BRNE _0x2080027
	LDD  R26,Y+44
	CPI  R26,LOW(0x18)
	BRNE _0x2080028
	LDI  R30,LOW(0)
	STD  Y+44,R30
_0x2080028:
	RJMP _0x2080029
_0x2080027:
	LDD  R26,Y+44
	CPI  R26,LOW(0x20)
	BRNE _0x208002A
	LDI  R30,LOW(1)
	STD  Y+44,R30
_0x208002A:
_0x2080029:
	RJMP _0x2080025
_0x2080026:
	RCALL SUBOPT_0x10
	BRNE _0x208002B
	LDD  R30,Y+44
	RCALL SUBOPT_0xB
	SBIW R30,1
	STD  Y+44,R30
	RCALL SUBOPT_0x44
	BRNE _0x208002C
	LDD  R26,Y+44
	CPI  R26,LOW(0xFF)
	BRNE _0x208002D
	LDI  R30,LOW(23)
	STD  Y+44,R30
_0x208002D:
	RJMP _0x208002E
_0x208002C:
	LDD  R30,Y+44
	CPI  R30,0
	BRNE _0x208002F
	LDI  R30,LOW(31)
	STD  Y+44,R30
_0x208002F:
_0x208002E:
	RJMP _0x2080025
_0x208002B:
	RCALL SUBOPT_0x24
	BRNE _0x2080030
	LDI  R18,LOW(1)
	RJMP _0x2080025
_0x2080030:
	RCALL SUBOPT_0x23
	BRNE _0x2080032
	LDI  R18,LOW(3)
	RJMP _0x2080025
_0x2080032:
	LDI  R18,LOW(0)
_0x2080025:
	LDI  R30,LOW(0)
	STD  Y+6,R30
	RJMP _0x2080019
_0x208001A:
	RCALL SUBOPT_0x12
	BREQ PC+2
	RJMP _0x2080033
	RCALL SUBOPT_0x44
	BRNE _0x2080034
	LDD  R30,Y+43
	CP   R30,R19
	BRNE _0x2080036
	RCALL SUBOPT_0x45
	BREQ _0x2080035
_0x2080036:
	RCALL SUBOPT_0x46
	__POINTW1FN _0x2080000,68
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x47
	__POINTW1FN _0x2080000,84
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x46
	RCALL SUBOPT_0x4C
_0x2080035:
	RJMP _0x2080038
_0x2080034:
	LDD  R30,Y+43
	CP   R30,R19
	BRNE _0x208003A
	RCALL SUBOPT_0x45
	BREQ _0x2080039
_0x208003A:
	RCALL SUBOPT_0x46
	__POINTW1FN _0x2080000,105
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x47
	__POINTW1FN _0x2080000,121
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x46
	RCALL SUBOPT_0x4C
_0x2080039:
_0x2080038:
	RCALL SUBOPT_0x26
	BRNE _0x208003F
	LDD  R30,Y+43
	SUBI R30,-LOW(1)
	STD  Y+43,R30
	RCALL SUBOPT_0x44
	BRNE _0x2080040
	LDD  R26,Y+43
	CPI  R26,LOW(0x3C)
	BRNE _0x2080041
	LDI  R30,LOW(0)
	STD  Y+43,R30
_0x2080041:
	RJMP _0x2080042
_0x2080040:
	LDD  R26,Y+43
	CPI  R26,LOW(0xD)
	BRNE _0x2080043
	LDI  R30,LOW(1)
	STD  Y+43,R30
_0x2080043:
_0x2080042:
	RJMP _0x208003E
_0x208003F:
	RCALL SUBOPT_0x10
	BRNE _0x2080044
	LDD  R30,Y+43
	RCALL SUBOPT_0xB
	SBIW R30,1
	STD  Y+43,R30
	RCALL SUBOPT_0x44
	BRNE _0x2080045
	LDD  R26,Y+43
	CPI  R26,LOW(0xFF)
	BRNE _0x2080046
	LDI  R30,LOW(59)
	STD  Y+43,R30
_0x2080046:
	RJMP _0x2080047
_0x2080045:
	LDD  R30,Y+43
	CPI  R30,0
	BRNE _0x2080048
	LDI  R30,LOW(12)
	STD  Y+43,R30
_0x2080048:
_0x2080047:
	RJMP _0x208003E
_0x2080044:
	RCALL SUBOPT_0x24
	BRNE _0x2080049
	LDI  R18,LOW(2)
	RJMP _0x208003E
_0x2080049:
	RCALL SUBOPT_0x23
	BRNE _0x208004B
	LDI  R18,LOW(3)
	RJMP _0x208003E
_0x208004B:
	LDI  R18,LOW(1)
_0x208003E:
	LDI  R30,LOW(1)
	STD  Y+6,R30
	RJMP _0x2080019
_0x2080033:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x208004C
	RCALL SUBOPT_0x44
	BRNE _0x208004D
	RCALL SUBOPT_0x4D
	BRNE _0x208004F
	RCALL SUBOPT_0x45
	BREQ _0x208004E
_0x208004F:
	RCALL SUBOPT_0x46
	__POINTW1FN _0x2080000,136
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x47
	__POINTW1FN _0x2080000,152
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x46
	RCALL SUBOPT_0x4E
_0x208004E:
	RJMP _0x2080051
_0x208004D:
	RCALL SUBOPT_0x4D
	BRNE _0x2080053
	RCALL SUBOPT_0x45
	BREQ _0x2080052
_0x2080053:
	RCALL SUBOPT_0x46
	__POINTW1FN _0x2080000,172
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x47
	__POINTW1FN _0x2080000,188
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x46
	RCALL SUBOPT_0x4E
_0x2080052:
_0x2080051:
	RCALL SUBOPT_0x26
	BRNE _0x2080058
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	ADIW R30,1
	RCALL SUBOPT_0x4F
	RCALL SUBOPT_0x44
	BRNE _0x2080059
	RCALL SUBOPT_0x50
	SBIW R26,60
	BRNE _0x208005A
	LDI  R30,LOW(0)
	STD  Y+41,R30
	STD  Y+41+1,R30
_0x208005A:
	RJMP _0x208005B
_0x2080059:
	RCALL SUBOPT_0x50
	CPI  R26,LOW(0x7E5)
	LDI  R30,HIGH(0x7E5)
	CPC  R27,R30
	BRNE _0x208005C
	LDI  R30,LOW(2010)
	LDI  R31,HIGH(2010)
	RCALL SUBOPT_0x4F
_0x208005C:
_0x208005B:
	RJMP _0x2080057
_0x2080058:
	RCALL SUBOPT_0x10
	BRNE _0x208005D
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	SBIW R30,1
	RCALL SUBOPT_0x4F
	RCALL SUBOPT_0x44
	BRNE _0x208005E
	RCALL SUBOPT_0x50
	CPI  R26,LOW(0xFFFF)
	LDI  R30,HIGH(0xFFFF)
	CPC  R27,R30
	BRNE _0x208005F
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	RCALL SUBOPT_0x4F
_0x208005F:
	RJMP _0x2080060
_0x208005E:
	RCALL SUBOPT_0x50
	CPI  R26,LOW(0x7D9)
	LDI  R30,HIGH(0x7D9)
	CPC  R27,R30
	BRNE _0x2080061
	LDI  R30,LOW(2020)
	LDI  R31,HIGH(2020)
	RCALL SUBOPT_0x4F
_0x2080061:
_0x2080060:
	RJMP _0x2080057
_0x208005D:
	RCALL SUBOPT_0x24
	BRNE _0x2080062
	LDI  R18,LOW(0)
	RJMP _0x2080057
_0x2080062:
	RCALL SUBOPT_0x23
	BRNE _0x2080064
	LDI  R18,LOW(3)
	RJMP _0x2080057
_0x2080064:
	LDI  R18,LOW(2)
_0x2080057:
	LDI  R30,LOW(2)
	STD  Y+6,R30
	RJMP _0x2080019
_0x208004C:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x2080019
	LDD  R26,Y+45
	CPI  R26,LOW(0x1)
	BRNE _0x2080066
	RCALL SUBOPT_0x51
	LDD  R30,Y+44
	LDD  R31,Y+44+1
	RCALL SUBOPT_0x5
	RCALL _rtc_set_date
	RJMP _0x2080067
_0x2080066:
	RCALL SUBOPT_0x51
	LDD  R30,Y+44
	RCALL SUBOPT_0x1
	RCALL _rtc_set_time
_0x2080067:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x2160009
_0x2080019:
	RJMP _0x2080014
_0x2160009:
	RCALL __LOADLOCR6
	ADIW R28,47
	RET

	.CSEG
_ds1621_get_status:
	RCALL __SAVELOCR2
	LDD  R30,Y+2
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x53
	LDI  R30,LOW(172)
	ST   -Y,R30
	RCALL SUBOPT_0x41
	SUBI R17,-LOW(1)
	ST   -Y,R17
	RCALL _i2c_write
	RCALL SUBOPT_0x0
	RCALL _i2c_read
	MOV  R16,R30
	RCALL _i2c_stop
	MOV  R30,R16
	RCALL __LOADLOCR2
	RJMP _0x2160002
_ds1621_set_status:
	RCALL _i2c_start
	LDD  R30,Y+1
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x42
	LDI  R30,LOW(172)
	RCALL SUBOPT_0x42
	LD   R30,Y
	RCALL SUBOPT_0x42
	RCALL _i2c_stop
	RJMP _0x2160004
_ds1621_set_temp:
	RCALL _i2c_start
	LDD  R30,Y+2
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x42
	LDD  R30,Y+1
	RCALL SUBOPT_0x42
	LD   R30,Y
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x0
	RCALL _i2c_write
	RCALL _i2c_stop
_0x20A0003:
	RCALL SUBOPT_0x54
	RCALL _ds1621_get_status
	ANDI R30,LOW(0x10)
	BRNE _0x20A0003
	RJMP _0x2160002
_ds1621_start:
	RCALL _i2c_start
	LD   R30,Y
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x42
	LDI  R30,LOW(238)
	RCALL SUBOPT_0x42
	RCALL _i2c_stop
	RJMP _0x2160001
_ds1621_init:
	RCALL SUBOPT_0x55
	LDD  R30,Y+1
	LSL  R30
	SUBI R30,-LOW(8)
	ST   -Y,R30
	RCALL _ds1621_set_status
	RCALL SUBOPT_0x55
	LDI  R30,LOW(162)
	RCALL SUBOPT_0x56
	RCALL _ds1621_set_temp
	RCALL SUBOPT_0x55
	LDI  R30,LOW(161)
	ST   -Y,R30
	RCALL SUBOPT_0x55
	RCALL _ds1621_set_temp
	RCALL SUBOPT_0x55
	RCALL _ds1621_start
	RJMP _0x2160008
_ds1621_temperature_10:
	SBIW R28,2
	ST   -Y,R17
	LDD  R30,Y+3
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x53
	LDI  R30,LOW(170)
	ST   -Y,R30
	RCALL SUBOPT_0x41
	SUBI R17,-LOW(1)
	ST   -Y,R17
	RCALL _i2c_write
	RCALL SUBOPT_0x13
	RCALL _i2c_read
	STD  Y+2,R30
	RCALL SUBOPT_0x0
	RCALL _i2c_read
	STD  Y+1,R30
	RCALL _i2c_stop
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R30,LOW(7)
	RCALL __ASRW12
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RCALL __MULW12
	LDD  R17,Y+0
	RJMP _0x2160008

	.CSEG
_rtc_read:
	ST   -Y,R17
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0xA0)
	RCALL SUBOPT_0x53
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x41
	MOV  R30,R17
	ORI  R30,1
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x0
	RCALL _i2c_read
	MOV  R17,R30
	RCALL _i2c_stop
	MOV  R30,R17
	RJMP _0x2160003
_rtc_write:
	RCALL _i2c_start
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0xA0)
	RCALL SUBOPT_0x42
	LDD  R30,Y+1
	RCALL SUBOPT_0x42
	LD   R30,Y
	RCALL SUBOPT_0x42
	RCALL _i2c_stop
	RJMP _0x2160002
_rtc_get_status:
	RCALL SUBOPT_0x58
	RCALL _rtc_read
	RCALL SUBOPT_0x59
	RCALL SUBOPT_0x5A
	BST  R30,1
	BLD  R2,2
	RCALL SUBOPT_0x5A
	RJMP _0x2160001
_rtc_init:
	ST   -Y,R17
	LDI  R17,LOW(144)
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x20C0003
	LDI  R17,LOW(176)
_0x20C0003:
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x59
	CLT
	BLD  R2,2
	LDD  R30,Y+2
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x0
	RCALL _rtc_write
	RCALL SUBOPT_0x54
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x5B
	RCALL _rtc_read
	ANDI R30,LOW(0x3F)
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x54
	LDI  R30,LOW(8)
	ST   -Y,R30
	ST   -Y,R17
	RCALL _rtc_write
	RJMP _0x2160003
_rtc_stop:
	RCALL SUBOPT_0x5D
	ORI  R30,0x80
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5F
	RJMP _0x2160001
_rtc_start:
	RCALL SUBOPT_0x5D
	ANDI R30,0x7F
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5F
	RJMP _0x2160001
_rtc_hold_off:
	RCALL SUBOPT_0x5D
	ANDI R30,0xBF
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5F
	RJMP _0x2160001
_rtc_hold_on:
	RCALL SUBOPT_0x5D
	ORI  R30,0x40
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5F
	RJMP _0x2160001
_rtc_read_bcd:
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x57
	RCALL _rtc_read
	ST   -Y,R30
	RCALL _bcd2bin
	RJMP _0x2160004
_rtc_write_bcd:
	RCALL SUBOPT_0x54
	RCALL SUBOPT_0x54
	RCALL SUBOPT_0x54
	RCALL _bin2bcd
	RCALL SUBOPT_0x5C
	RJMP _0x2160002
_rtc_write_word:
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x55
	LDD  R30,Y+2
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x55
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	ST   -Y,R30
	RCALL SUBOPT_0x55
	RCALL _rtc_write
_0x2160008:
	ADIW R28,4
	RET
_rtc_write_date:
	LDD  R30,Y+4
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x60
	RCALL _bin2bcd
	MOV  R26,R30
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	LSL  R30
	OR   R30,R26
	RCALL SUBOPT_0x5C
	RJMP _0x2160006
_rtc_get_time:
	RCALL SUBOPT_0x40
	RCALL _rtc_hold_on
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x13
	RCALL _rtc_read_bcd
	LD   R26,Y
	LDD  R27,Y+1
	RCALL SUBOPT_0x61
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x61
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x5B
	RCALL _rtc_read_bcd
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x61
	RCALL _rtc_hold_off
_0x2160007:
	ADIW R28,9
	RET
_rtc_set_time:
	RCALL SUBOPT_0x60
	RCALL _rtc_stop
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x54
	RCALL SUBOPT_0x62
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x62
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x5B
	LDD  R30,Y+5
	RJMP _0x2160005
_rtc_get_date:
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x63
	RCALL _rtc_hold_on
	RCALL SUBOPT_0x63
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _rtc_read
	MOV  R17,R30
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x15
	RCALL _rtc_read
	ANDI R30,LOW(0x1F)
	ST   -Y,R30
	RCALL _bcd2bin
	RCALL SUBOPT_0x35
	ST   X,R30
	RCALL SUBOPT_0x63
	RCALL _rtc_hold_off
	MOV  R30,R17
	ANDI R30,LOW(0x3F)
	ST   -Y,R30
	RCALL _bcd2bin
	RCALL SUBOPT_0x36
	ST   X,R30
	MOV  R26,R17
	LDI  R27,0
	LDI  R30,LOW(6)
	RCALL __ASRW12
	MOV  R17,R30
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x2
	RCALL _rtc_read
	MOV  R16,R30
	RCALL SUBOPT_0x63
	LDI  R30,LOW(17)
	ST   -Y,R30
	RCALL _rtc_read
	MOV  R31,R30
	LDI  R30,0
	OR   R30,R16
	MOVW R18,R30
	MOV  R30,R18
	ANDI R30,LOW(0x3)
	CP   R17,R30
	BREQ _0x20C0004
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x2
	__ADDWRN 18,19,1
	ST   -Y,R19
	ST   -Y,R18
	RCALL _rtc_write_word
_0x20C0004:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X+,R18
	ST   X,R19
	RCALL __LOADLOCR4
	ADIW R28,11
	RET
_rtc_set_date:
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x2
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x5
	RCALL _rtc_write_word
	RCALL SUBOPT_0x60
	RCALL _rtc_stop
	RCALL SUBOPT_0x60
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDD  R30,Y+5
	ST   -Y,R30
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	RCALL SUBOPT_0x5
	RCALL _rtc_write_date
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x15
	LDD  R30,Y+4
_0x2160005:
	ST   -Y,R30
	RCALL SUBOPT_0x62
	RCALL _rtc_start
_0x2160006:
	ADIW R28,5
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G107:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G107
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G107
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G107
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G107
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G107:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G107
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G107
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G107
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G107
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2160001
_lcd_write_byte:
	RCALL __lcd_ready
	RCALL SUBOPT_0x57
	RCALL __lcd_write_data
	RCALL __lcd_ready
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	RCALL SUBOPT_0x64
	RJMP _0x2160004
__lcd_read_nibble_G107:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G107
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G107
    andi  r30,0xf0
	RET
_lcd_read_byte0_G107:
	RCALL __lcd_delay_G107
	RCALL __lcd_read_nibble_G107
    mov   r26,r30
	RCALL __lcd_read_nibble_G107
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	RCALL SUBOPT_0xB
	SUBI R30,LOW(-__base_y_G107)
	SBCI R31,HIGH(-__base_y_G107)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x64
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x2160004:
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x64
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x64
	RCALL __lcd_ready
	RCALL SUBOPT_0x13
	RCALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x20E0004
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0x0
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x20E0004:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	RJMP _0x2160001
_lcd_puts:
	ST   -Y,R17
_0x20E0005:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RCALL SUBOPT_0x28
	BREQ _0x20E0007
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x20E0005
_0x20E0007:
_0x2160003:
	LDD  R17,Y+0
_0x2160002:
	ADIW R28,3
	RET
__long_delay_G107:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G107:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G107
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2160001
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G107,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G107,3
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x65
	RCALL __long_delay_G107
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G107
	RCALL __long_delay_G107
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x64
	RCALL __long_delay_G107
	RCALL SUBOPT_0x5B
	RCALL __lcd_write_data
	RCALL __long_delay_G107
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x64
	RCALL __long_delay_G107
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G107
	CPI  R30,LOW(0x5)
	BREQ _0x20E000B
	LDI  R30,LOW(0)
	RJMP _0x2160001
_0x20E000B:
	RCALL __lcd_ready
	RCALL SUBOPT_0x15
	RCALL __lcd_write_data
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x2160001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.DSEG
_g_key_ASCII:
	.BYTE 0x1
_g_Trame_TX:
	.BYTE 0x2
___rtc_status:
	.BYTE 0x1
_display_buffer_ligne0:
	.BYTE 0x11
_display_buffer_ligne1:
	.BYTE 0x11
_etat:
	.BYTE 0x1
_etat_1:
	.BYTE 0x1
__seed_G101:
	.BYTE 0x4
_g_data_S1030000000:
	.BYTE 0x2
_g_data_aff_S1030000000:
	.BYTE 0x1
_edge_S1030000000:
	.BYTE 0x1
_bitcount_RX_S1030000000:
	.BYTE 0x1
_bitcount_TX_S1030000000:
	.BYTE 0x1
_is_up_S1030000000:
	.BYTE 0x1
_shift_S1030000000:
	.BYTE 0x1
_Etat_BP_S1040000000:
	.BYTE 0x1
__base_y_G107:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 33 TIMES, CODE SIZE REDUCTION:30 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1:
	ST   -Y,R30
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(16)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	ST   -Y,R30
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 56 TIMES, CODE SIZE REDUCTION:163 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 177 TIMES, CODE SIZE REDUCTION:174 WORDS
SUBOPT_0x5:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 49 TIMES, CODE SIZE REDUCTION:94 WORDS
SUBOPT_0x6:
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 50 TIMES, CODE SIZE REDUCTION:96 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 46 TIMES, CODE SIZE REDUCTION:43 WORDS
SUBOPT_0x8:
	RCALL SUBOPT_0x5
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	RCALL SUBOPT_0x5
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xA:
	LDS  R30,_etat
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 35 TIMES, CODE SIZE REDUCTION:66 WORDS
SUBOPT_0xB:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0xC:
	RCALL SUBOPT_0xA
	LDS  R26,_etat_1
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(_menu*2)
	LDI  R31,HIGH(_menu*2)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xE:
	RCALL _Affiche_LCD
	RJMP _Affiche_fleches

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:38 WORDS
SUBOPT_0xF:
	MOV  R30,R19
	RCALL SUBOPT_0xB
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x10:
	CPI  R30,LOW(0x2F)
	LDI  R26,HIGH(0x2F)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x11:
	CPI  R30,LOW(0x3E)
	LDI  R26,HIGH(0x3E)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(_menu_ECHAP*2)
	LDI  R31,HIGH(_menu_ECHAP*2)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(6)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	RCALL __MULB1W2U
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	RCALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	LDI  R30,LOW(255)
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __DIVW21U
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	RCALL __MULW12U
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RCALL __MULW12U
	MOVW R26,R30
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1B:
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1C:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x1D:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1E:
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x5
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0x5
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RCALL SUBOPT_0x5
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RCALL SUBOPT_0x5
	RCALL _rtc_get_time
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:58 WORDS
SUBOPT_0x20:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x21:
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x22:
	ST   -Y,R8
	ST   -Y,R11
	ST   -Y,R10
	ST   -Y,R13
	ST   -Y,R12
	RCALL _RegleHTR
	LDI  R30,LOW(5)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x23:
	CPI  R30,LOW(0x3B)
	LDI  R26,HIGH(0x3B)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x24:
	CPI  R30,LOW(0x37)
	LDI  R26,HIGH(0x37)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x25:
	RCALL _lcd_gotoxy
	LDI  R30,LOW(15)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x26:
	MOV  R30,R17
	RCALL SUBOPT_0xB
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x27:
	RCALL _Affiche_LCD
	LDI  R16,LOW(1)
	CPI  R19,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x28:
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x29:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2A:
	ADIW R26,4
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2B:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x2C:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RCALL SUBOPT_0x5
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2D:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2E:
	SBIW R30,4
	RJMP SUBOPT_0x1B

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x2F:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RCALL SUBOPT_0x5
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x30:
	RCALL SUBOPT_0x2D
	RJMP SUBOPT_0x2E

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x31:
	RCALL SUBOPT_0x1C
	RJMP SUBOPT_0x2A

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x32:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x33:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x34:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x35:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x36:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x38:
	LDS  R30,_g_data_S1030000000
	LDS  R31,_g_data_S1030000000+1
	LSR  R31
	ROR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x39:
	STS  _g_data_S1030000000,R30
	STS  _g_data_S1030000000+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3A:
	LDS  R30,_g_data_aff_S1030000000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3B:
	MOV  R30,R17
	LDI  R26,LOW(_unshifted*2)
	LDI  R27,HIGH(_unshifted*2)
	RCALL SUBOPT_0xB
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3C:
	MOVW R0,R30
	LPM  R26,Z
	RCALL SUBOPT_0x3A
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3D:
	ADIW R30,1
	LPM  R0,Z
	STS  _g_key_ASCII,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3E:
	MOV  R30,R17
	LDI  R26,LOW(_shifted*2)
	LDI  R27,HIGH(_shifted*2)
	RCALL SUBOPT_0xB
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3F:
	MOV  R17,R16
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x40:
	LDD  R30,Y+8
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	RCALL _i2c_write
	RJMP _i2c_start

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x42:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x43:
	RCALL _i2c_read
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x44:
	LDD  R30,Y+45
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x45:
	LDD  R26,Y+6
	CP   R18,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x46:
	MOVW R30,R28
	ADIW R30,24
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x47:
	MOVW R30,R28
	ADIW R30,7
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x48:
	RCALL SUBOPT_0x5
	LDD  R30,Y+48
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x49:
	LDD  R30,Y+51
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x4A:
	LDD  R30,Y+53
	LDD  R31,Y+53+1
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4B:
	MOVW R30,R28
	ADIW R30,9
	RCALL SUBOPT_0x5
	RCALL _Affiche_LCD
	LDD  R16,Y+44
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4C:
	MOVW R30,R28
	ADIW R30,9
	RCALL SUBOPT_0x5
	RCALL _Affiche_LCD
	LDD  R19,Y+43
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4D:
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	CP   R30,R20
	CPC  R31,R21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4E:
	MOVW R30,R28
	ADIW R30,9
	RCALL SUBOPT_0x5
	RCALL _Affiche_LCD
	__GETWRS 20,21,41
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4F:
	STD  Y+41,R30
	STD  Y+41+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x50:
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x51:
	LDD  R30,Y+46
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x52:
	LSL  R30
	ORI  R30,LOW(0x90)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x53:
	MOV  R17,R30
	RCALL _i2c_start
	ST   -Y,R17
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x54:
	LDD  R30,Y+2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x55:
	LDD  R30,Y+3
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x56:
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x57:
	LDD  R30,Y+1
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x58:
	LD   R30,Y
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x59:
	STS  ___rtc_status,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5A:
	LDS  R30,___rtc_status
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5B:
	LDI  R30,LOW(4)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5C:
	ST   -Y,R30
	RJMP _rtc_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5D:
	LD   R30,Y
	ST   -Y,R30
	RCALL _rtc_get_status
	RJMP SUBOPT_0x5A

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5E:
	RCALL SUBOPT_0x59
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5F:
	RCALL SUBOPT_0x5A
	RJMP SUBOPT_0x5C

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x60:
	LDD  R30,Y+4
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x61:
	ST   X,R30
	RJMP SUBOPT_0x40

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x62:
	RCALL _rtc_write_bcd
	RJMP SUBOPT_0x60

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x63:
	LDD  R30,Y+10
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x64:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x65:
	RCALL __long_delay_G107
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G107


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
